#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#  clearBoundaryFields.py
#    boundary fieldを設定する。
#
#       11/05/17    バグ修正（field検索でfolderが検索されていたのを修正）
#

import os
import sys
import glob
import pyTreeFoam

workdir = ""
Pname = []


#  compSP
def compSP(a):
  i=0
  while a[i] == " ":
    i = i + 1
  strA = a[i:]
  return strA

#
#  getPatchNameFromBoundary
#
def getPatchNameFromBoundary():
  name = []
  boundaryFile = "constant/polyMesh/boundary"
  f = open(boundaryFile)
  fileCont=[]
  for line in f.readlines():
    fileCont.append(line)
  i = 0
  while (fileCont[i])[0] != "(":
    i = i + 1
  i = i + 1
  while (i < len(fileCont)) and ((fileCont[i])[0] != ")"):
    name.append((fileCont[i])[:-1])
    i = i + 6
  rname = []
  for a in name:
    a = compSP(a)
    rname.append(a)
  return rname

#
#  createBoundary
#
def createBoundary(Pname):
  cont = ""
  for name in Pname:
    cont = cont + "    " + name + "\n"
    cont = cont + "    {\n"
    cont = cont + "        type    zeroGradient;\n"
    cont = cont + "    }\n"
  cont = "{\n" + cont + "}\n"
  return cont

#
#  remakeBoundaryFields
#
def remakeBoundaryFields(cont):
  fieldName = []
  wdir = os.getcwd()
  [folders, files] = pyTreeFoam.getFoldersFiles(wdir+"/0")
  for name in files:
    if name[-1] != "~":
      fieldName.append(name)

  """
  files = glob.glob("0/*")
  for name in files:
    a=name.split("/")
    if a[-1][-1] != "~":
        fieldName.append(a[-1])
  """
  remakeTergetBoundaryFields(fieldName)



def remakeTergetBoundaryFields(fieldName):
  Pname = getPatchNameFromBoundary()
  cont = createBoundary(Pname)
  for name in fieldName:
    print "    " + name + "..."
    f = open("0/" + name)
    fileCont = []
    for line in f.readlines():
      fileCont.append(line)
    i=0; heder = ""
    while (i < len(fileCont)):
      line = fileCont[i]
      if line[:8] == "boundary":
        heder = heder + line
        i = len(fileCont) + 1
      else:
        heder = heder + line
        i = i + 1        
    if i != len(fileCont) + 1:
      print "      baoundaryFieldがありません。追加しました。"
      heder = heder + "boundaryField\n"
    contAll = heder + cont + "// ************************************************************************* //\n"
    f.close
    f = open("0/" + name,"w")
    f.write(contAll)
    f.close


#
# メイン
#
if __name__ == "__main__":
    Pname = getPatchNameFromBoundary()
    cont = createBoundary(Pname)
    remakeBoundaryFields(cont)

