#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   editBoundaryConditiondDialog.py
#
#       12/01/03    patchの削除を可能にした。
#          01/08    patch名の修正を可能にした
#          01/17    patch削除時ﾊﾞｸﾞ修正（最後のcellにｺﾞﾐが残る）
#          02/05    windowClose時の終了処理追加
#          02/11    patch名変更、削除時にglobal変数を設定する様に変更（ﾊﾞｸﾞ修正）
#          02/18    ﾒﾆｭｰkeyとｼｮｰﾄｶｯﾄkey追加
#          02/19    読み込み時にｹﾞｰｼﾞ追加
#          02/25    gridEditorｺﾏﾝﾄﾞに対応できる様、cellDataの読込みをtimerEventで実施
#          02/26    終了時にwindowSizeを保存
#          03/10    iconNameを変数に修正
#          03/25    openメニュー追加
#          04/01    save時にもｹﾞｰｼﾞを追加
#          04/22    field非表示、表示順の設定追加
#          04/23    field保存時にｴﾗｰ表示追加
#          05/11    fieldCopy時に_copy0～_copy9まで可能な様に修正
#          05/25    ｱｲｺﾝの定義を相対pathに変更。
#          06/24    field削除をゴミ箱へ移動に変更。
#          08/04    cell内容変更して終了する時、保存確認するよう変更
#          08/05    最大cell内行数を変更
#          08/11    patch名変更・削除時にcell修正チェック追加
#          08/14    field名表示のバグ修正（field削除時、表示のみ削除できず）
#


# generated by wxGlade 0.6.3 on Sat Apr 23 14:08:58 2011

#------------2行修正---------------
#   ＜size=gridSize を __init__ に追加＞
#   wx.Frame.__init__(self, size=gridSize, *args, **kwds)
#
#   ＜コメントアウト＞
#   #sizer_1.Fit(self)
#
#   ・アイコンのDirを書き直す（絶対Path→相対path）
#


import wx
import wx.grid
import string
import thread
import os
import glob
import gio
import treefoam
import pyTreeFoam
import getFoamContents
import saveCSV_dialog
import gaugeDDialog
import openGridEditorDialog
import openFieldForGridEditorDDialog

openID = wx.NewId()
saveID = wx.NewId()
saveCSVID = wx.NewId()
reloadID = wx.NewId()
exitID = wx.NewId()
renamePatchID = wx.NewId()
delPatchID = wx.NewId()
copyID = wx.NewId()
pasteID = wx.NewId()
toolOpenID = wx.NewId()
toolSaveID = wx.NewId()
toolSaveCSVID = wx.NewId()
toolReloadID = wx.NewId()
toolExitID = wx.NewId()
toolCopyID = wx.NewId()
toolPasteID = wx.NewId()
allDispID = wx.NewId()
nonDispID = wx.NewId()
dispID = wx.NewId()



# begin wxGlade: extracode
# end wxGlade

gridTitle = ""                          #Gridのタイトル
boundaryDir = ""                        #boundaryのdir
dataDir = ""                            #fieldデータを取得したdir
frame_1 = ""
nTreeFoam = ""
clipBoard = ""
delPatchName = ""                       #削除するpatch名
gridSize = (500, 400)                   #gridのサイズ
displayFieldsFile = ".displayField"     #表示させるfield名を保存するﾌｧｲﾙ名
maxRowsInCell = 10                      #cell内の最大表示行数


colNames = []       #  データ構造は、field単位で構成
rowNames = []       #       field1      field2
data = []           #data=[[p1,p2,..],[p1,p2,..],...]
copyCol = 0; copyRow = 0
copyValue = ""; copyValues = []
curRow = 0; curCol = 0



def Show(nTreeFoam1, title, bdir, wdir, col):
    global dataDir, gridTitle, boundaryDir, colNames, rowNames, data, nTreeFoam
    nTreeFoam = nTreeFoam1
    gridTitle = title           #タイトル
    boundaryDir = bdir          #boundaryのdir
    dataDir = wdir              #fieldのdir
    colNames = col              #fieldName
    if len(colNames) == 0:
        [folders, colNames] = pyTreeFoam.getFoldersFiles(dataDir)
    rowNames = getRowNamesFromBoundary(boundaryDir)     #patchName
    initializeGrid()            #初期化（gridNo、title設定）
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):

        savePath = os.getcwd()
        treeFoamPath = os.getenv("HOME") + "/TreeFoam"
        os.chdir(treeFoamPath)

        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        #wx.Frame.__init__(self, *args, **kwds)
        wx.Frame.__init__(self, size=gridSize, *args, **kwds)
        # Menu Bar
        self.frame_1_menubar = wx.MenuBar()
        self.menuFile = wx.Menu()
        self.menuOpen = wx.MenuItem(self.menuFile, openID, u"開く(&O)", u"boundaryとfieldを開く", wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuOpen)
        self.menuSave = wx.MenuItem(self.menuFile, saveID, u"保存(&S)", u"保存します", wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuSave)
        self.menuSaveCSV = wx.MenuItem(self.menuFile, saveCSVID, u"CSV保存(&V)", u"CSV形式で保存します", wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuSaveCSV)
        self.menuReload = wx.MenuItem(self.menuFile, reloadID, u"再読み込み(&R)", u"再読込みします", wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuReload)
        self.menuFile.AppendSeparator()
        self.menuExit = wx.MenuItem(self.menuFile, exitID, u"閉じる(&Q)", u"閉じる", wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuExit)
        self.frame_1_menubar.Append(self.menuFile, u"ファイル(&F)")
        self.menuEdit = wx.Menu()
        self.menuRenamePatch = wx.MenuItem(self.menuEdit, renamePatchID, u"patch名変更", u"patch名を変更します", wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuRenamePatch)
        self.menuDelPatch = wx.MenuItem(self.menuEdit, delPatchID, u"patch削除", u"patchを削除します\n削除後は元に戻りません", wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuDelPatch)
        self.menuEdit.AppendSeparator()
        self.menuCellCopy = wx.MenuItem(self.menuEdit, copyID, u"cellコピー(&C)\tCtrl+C", u"cell内容をコピーします", wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuCellCopy)
        self.menuCellPaste = wx.MenuItem(self.menuEdit, pasteID, u"cell貼付け(&P)\tCtrl+V", u"cell内容をを貼付けます", wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuCellPaste)
        self.frame_1_menubar.Append(self.menuEdit, u"編集(&E)")
        self.menuView = wx.Menu()
        self.menuDispAllFields = wx.MenuItem(self.menuView, wx.NewId(), u"表示設定クリア、全field表示(&A)", u"表示設定をクリアして、全fieldを表示します", wx.ITEM_NORMAL)
        self.menuView.AppendItem(self.menuDispAllFields)
        self.menuNonDisp = wx.MenuItem(self.menuView, wx.NewId(), u"選択したfieldを非表示(&H)", u"選択したfieldを非表示にします", wx.ITEM_NORMAL)
        self.menuView.AppendItem(self.menuNonDisp)
        self.menuDisp = wx.MenuItem(self.menuView, dispID, u"fieldの再表示、表示順変更(&R)", u"非表示fieldを再表示、表示順を変更します", wx.ITEM_NORMAL)
        self.menuView.AppendItem(self.menuDisp)
        self.frame_1_menubar.Append(self.menuView, u"表示(&V)")
        self.SetMenuBar(self.frame_1_menubar)
        # Menu Bar end
        self.frame_1_statusbar = self.CreateStatusBar(1, wx.ST_SIZEGRIP)
        
        # Tool Bar
        self.frame_1_toolbar = wx.ToolBar(self, -1, style=wx.TB_HORIZONTAL|wx.TB_NOALIGN)
        self.SetToolBar(self.frame_1_toolbar)
        self.frame_1_toolbar.AddLabelTool(toolOpenID, "open", wx.Bitmap("./icons/fileopen.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, u"開く", u"boundaryとfieldを開く")
        self.frame_1_toolbar.AddLabelTool(toolSaveID, "save", wx.Bitmap("./icons/save.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, u"保存", u"boundaryとFieldを保存します")
        self.frame_1_toolbar.AddLabelTool(toolSaveCSVID, "saveCSV", wx.Bitmap("./icons/document-revert.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, u"CSV保存", u"CSV形式で保存")
        self.frame_1_toolbar.AddLabelTool(toolReloadID, "reload", wx.Bitmap("./icons/reload.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, u"再読込み", u"再読込みします")
        self.frame_1_toolbar.AddLabelTool(toolExitID, "exit", wx.Bitmap("./icons/exit.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, u"閉じる", u"閉じる")
        self.frame_1_toolbar.AddSeparator()
        self.frame_1_toolbar.AddLabelTool(toolCopyID, "cellCopy", wx.Bitmap("./icons/copy.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, u"cell内容のコピー", u"cell内容をコピーします")
        self.frame_1_toolbar.AddLabelTool(toolPasteID, "cellPaste", wx.Bitmap("./icons/paste.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, u"cell内容の貼付け", u"cell内容を貼り付けます")
        # Tool Bar end
        self.grid_1 = wx.grid.Grid(self, -1, size=(1, 1))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_MENU, self.onOpen, self.menuOpen)
        self.Bind(wx.EVT_MENU, self.onSave, self.menuSave)
        self.Bind(wx.EVT_MENU, self.onSaveCSV, self.menuSaveCSV)
        self.Bind(wx.EVT_MENU, self.onReload, self.menuReload)
        self.Bind(wx.EVT_MENU, self.onExit, self.menuExit)
        self.Bind(wx.EVT_MENU, self.onRenamePatch, self.menuRenamePatch)
        self.Bind(wx.EVT_MENU, self.onDelPatch, self.menuDelPatch)
        self.Bind(wx.EVT_MENU, self.onCellCopy, self.menuCellCopy)
        self.Bind(wx.EVT_MENU, self.onCellPaste, self.menuCellPaste)
        self.Bind(wx.EVT_MENU, self.onDispAllFields, self.menuDispAllFields)
        self.Bind(wx.EVT_MENU, self.onNonDisp, self.menuNonDisp)
        self.Bind(wx.EVT_MENU, self.onDispFields, self.menuDisp)
        self.Bind(wx.EVT_TOOL, self.onOpen, id=toolOpenID)
        self.Bind(wx.EVT_TOOL, self.onSave, id=toolSaveID)
        self.Bind(wx.EVT_TOOL, self.onSaveCSV, id=toolSaveCSVID)
        self.Bind(wx.EVT_TOOL, self.onReload, id=toolReloadID)
        self.Bind(wx.EVT_TOOL, self.onExit, id=toolExitID)
        self.Bind(wx.EVT_TOOL, self.onCellCopy, id=toolCopyID)
        self.Bind(wx.EVT_TOOL, self.onCellPaste, id=toolPasteID)
        self.Bind(wx.grid.EVT_GRID_CMD_CELL_RIGHT_CLICK, self.onRightClick, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_CMD_CELL_LEFT_CLICK, self.onLeftClick, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_CMD_LABEL_RIGHT_CLICK, self.onLabelRightClick, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_CMD_SELECT_CELL, self.onAutoCellSize, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_EDITOR_SHOWN, self.onEditorShown, self.grid_1)

        # end wxGlade

        os.chdir(savePath)

        self.Bind(wx.EVT_CLOSE, self.onCloseWindow)
        #self.Bind(wx.EVT_KEY_DOWN, self.onKeyDownEvent)

        #timerEventを発生させ、eventでcellDataを読み込む
        self.Bind(wx.EVT_TIMER, self.getCellData)
        self.timer = wx.Timer(self)
        self.timer.Start(100)           #0.1sのタイマ設定


    def __set_properties(self):
        global clipBoard, data
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("Edit BoundaryFields")
        self.frame_1_statusbar.SetStatusWidths([-1])
        # statusbar fields
        frame_1_statusbar_fields = ["frame_1_statusbar"]
        for i in range(len(frame_1_statusbar_fields)):
            self.frame_1_statusbar.SetStatusText(frame_1_statusbar_fields[i], i)
        self.frame_1_toolbar.Realize()
        self.grid_1.CreateGrid(1, 1)
        # end wxGlade

        #表を作成（colLabel、rowLabeの表のみ）
        #self.SetTitle("Edit BoundaryFields" + gridTitle)
        self.SetTitle("gridEditor" + gridTitle)
        self.grid_1.CreateGrid(len(rowNames), len(colNames))
        self.createMatrix()
        self.grid_1.AutoSize()

        #pouupMenuをセット
        self.setPopupMenu()
        self.setLabelPopupMenu()
        self.setFieldPopupMenu()
        #statusBarをクリア
        self.clearStatus()
        #clipBoardを定義
        try:
            clipBoardPath = os.environ["TreeFoamPath"]
        except:
            clipBoardPath = os.environ["HOME"]
        clipBoard = clipBoardPath + "/clipBoard"


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_1.Add(self.grid_1, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        #sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #
    #  getCellData
    #    cellデータの読込み
    def getCellData(self, event):
        global dataDir, colNames, rowNames, data
        #timerEventを停止
        self.timer.Stop()
        #cellDataの読込み
        #data = getPatchDataFromBoundaryFields(dataDir, colNames, rowNames)
        data = self.loadFromGaugeDialog(dataDir, colNames, rowNames)
        self.setMatrixData()
        self.grid_1.AutoSize()
        self.checkBadField(colNames, data)
        #レイアウトし直す
        self.Layout()



    #----menu---------------------
    #Open
    def onOpen(self, event): # wxGlade: MyFrame.<event_handler>
        #gridEditorのglobal変数を取得
        self.setGlobalValue()
        #編集しているdirectory（数字のフォルダ）を取得
        [boundaryDir, editSubDir] = self.getDirectoryFromGrid()
        editSubDirList = editSubDir.split("/")
        time = ""
        try:
            #数字フォルダ？
            a = float(editSubDirList[-1])
            editDir = editSubDir
            time = editSubDirList[-1]
        except:
            #数字フォルダに設定
            editDir = "/" + string.join(editSubDirList[:-1], "/")
            time = editSubDirList[-2]
        #folderとfieldのlistを取得
        FFlist = treefoam.setEditFolders(editDir)
        title = u"boundaryFieldの編集"
        mess = u"選択された boundaryField を編集します"
        openGridEditorDialog.Show(nTreeFoam, title, mess, FFlist, editDir, time)
        event.Skip()

    #Save
    def onSave(self, event): # wxGlade: MyFrame.<event_handler>
        global dataDir, colNames, boundaryDir
        #global変数（dir, colNames, rowNames)を設定
        self.setGlobalValue()
        fieldCellData = self.getAllFieldCellsData()
        intData = self.getInternalFieldCellData()
        self.saveAtGaugeDialog(dataDir, colNames, rowNames, fieldCellData, intData)
        defineCellData = self.getDefineCellData()
        error = self.replaceDefineData(defineCellData)
        if error[0] == "OK":
            print u"boundaryFieldを保存しました"
        else:
            print u"error:boundaryが保存できませんでした"
        #保存フラグクリア
        self.alarmSaveFlagClear()

    #SaveCSV
    def onSaveCSV(self, event): # wxGlade: MyFrame.<event_handler>
        self.saveCSV()

    #Reload
    def onReload(self, event): # wxGlade: MyFrame.<event_handler>
        global data, boundaryDir, rowNames
        #boundaryDir, dataDir, rowNames, colNamesをGridから取得
        self.setGlobalValue()
        #rowNamesをboundayから取得
        rowNames = getRowNamesFromBoundary(boundaryDir)
        #rowNames, colNamesから再読込し、gridを作成
        self.readDataMakeGrid()
        #保存フラグクリア
        self.alarmSaveFlagClear()

    #Exit
    def onExit(self, event): # wxGlade: MyFrame.<event_handler>
        if self.checkSaveFlag() != 0:
            return
        #closeするGridNoを削除する
        title = self.GetTitle()
        gridSize = self.GetSize()
        self.setGlobalValue()
        endingGrid(title, gridSize, colNames, dataDir)
        #表示順を保存
        saveDisplayFieldsIfFile(colNames, dataDir)
        #Frame（Grid）をcloseする
        self.Destroy()

    #CellCopy
    def onCellCopy(self, event): # wxGlade: MyFrame.<event_handler>
        self.getCopyValues()
        event.Skip()

    #CellPaste
    def onCellPaste(self, event): # wxGlade: MyFrame.<event_handler>
        self.pasteCopyValues()
        self.grid_1.AutoSizeColumn(curCol, True)
        self.grid_1.AutoSizeRow(curRow, True)
        self.grid_1.ForceRefresh()
        event.Skip()

    #renmePatch
    def onRenamePatch(self, event): # wxGlade: MyFrame.<event_handler>
        print "patch名を変更します。"
        self.onRenamePatchName(event)

    #deletePatch
    def onDelPatch(self, event): # wxGlade: MyFrame.<event_handler>
        print "patchを削除します。"
        self.onDeletePatch(event)

    #全field表示
    def onDispAllFields(self, event): # wxGlade: MyFrame.<event_handler>
        print "全fieldを表示します。表示設定はクリアしました。"
        self.onDisplayAllFields(event)

    #fieldの非表示
    def onNonDisp(self, event): # wxGlade: MyFrame.<event_handler>
        self.onNonDisplayFields(event)

    #fieldの非表示、表示設定、表示順の変更
    def onDispFields(self, event): # wxGlade: MyFrame.<event_handler>
        print "表示設定を変更します。"
        self.onHideDisplayFields(event)

    #AutoCellSize(cell選択時)
    def onAutoCellSize(self, event): # wxGlade: MyFrame.<event_handler>
        global curRow, curCol
        curRow = event.GetRow()
        curCol = event.GetCol()
        self.grid_1.AutoSizeColumn(curCol, True)
        self.grid_1.AutoSizeRow(curRow, True)
        self.grid_1.ForceRefresh()
        event.Skip()

    #leftClick
    def onLeftClick(self, event): # wxGlade: MyFrame.<event_handler>
        curRow = event.GetRow()
        curCol = event.GetCol()
        self.grid_1.SetGridCursor(curRow, curCol)
        self.grid_1.ClearSelection()
        #cursorを設定するのみの為、event.Skip()しない
        #event.Skip()

    #windowClose時
    def onCloseWindow(self, event):
        #保存フラグをチェック
        if self.checkSaveFlag() != 0:
            return
        #終了処理開始
        try:
            title = self.GetTitle()
            gridSize = self.GetSize()
            self.setGlobalValue()
            endingGrid(title, gridSize, colNames, dataDir)
            #表示順を保存
            saveDisplayFieldsIfFile(colNames, dataDir)
        except:
            title = "エラー"
            message = "書込エラーが発生しました。\n  強制終了します。"
            self.errDialog(title, message)
        self.Destroy()

    def onEditorShown(self, event):
        self.alarmSaveFlagSet()          #保存フラグセット

    #-------pop up menu (mouse event)-------------
    def onRightClick(self, event): # wxGlade: MyFrame.<event_handler>
        global copyRow, copyCol, curRow, curCol
        curRow = event.GetRow()
        curCol = event.GetCol()
        pos = event.GetPosition()
        self.grid_1.PopupMenu(self.popupmenu, pos)
        event.Skip()

    #popupMenu初期化
    def setPopupMenu(self):
        self.popupmenu = wx.Menu()
        menu = [u"cellコピー\tCtrl+C", u"cell貼付\tCtrl+V", "-",
                u"全field表示", u"選択したfieldを非表示",
                u"field表示順変更"]
        for text in menu:
            if text == "-":
                self.popupmenu.AppendSeparator()
            else:
                item = self.popupmenu.Append(-1, text)
                self.Bind(wx.EVT_MENU, self.OnPopItemSelected, item)

    #popupMenu実行    
    def OnPopItemSelected(self, event):
        PPitem = self.popupmenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        #cellコピー
        if text == u"cellコピー":
            self.onCellCopy(event)
        #cell貼付
        elif text == u"cell貼付":
            self.onCellPaste(event)
        #表示設定クリア、全field表示
        elif text == u"全field表示":
            self.onDisplayAllFields(event)
        #選択したfieldを非表示
        elif text == u"選択したfieldを非表示":
            self.onNonDisplayFields(event)
        #fieldの再表示
        elif text == u"field表示順変更":
            self.onHideDisplayFields(event)

    #-------pop up menu (label righy click) ---------------
    def onLabelRightClick(self, event): # wxGlade: MyFrame.<event_handler>
        global rowNames, colNames, delPatchName, curRow, curCol
        curRow = event.GetRow()
        curCol = event.GetCol()
        pos = event.GetPosition()
        if (curCol == -1) and (curRow >= 2):        #patch(row)の選択？
            #行を選択？
            col=0
            flag = 0
            while col < len(colNames)+1:
                if (self.grid_1.IsInSelection(curRow, col) != True):
                    flag = 1
                    break
                col += 1
            if flag == 0:
                #global変数（dir, colNames, rowNames)を設定
                self.setGlobalValue()
                #削除するpatch名を保存
                delPatchName = rowNames[curRow-2]
                #popupmenuを表示
                self.grid_1.ClearSelection()
                self.grid_1.SelectRow(curRow, False)
                self.grid_1.PopupMenu(self.popupLabelMenu, pos)
        if (curCol >= 1) and (curRow == -1):        #field(col)の選択？
            #列を選択？
            row =0
            flag = 0
            while row < len(rowNames)+2:
                if (self.grid_1.IsInSelection(row, curCol) != True):
                    flag = 1
                    break
                row += 1
            if flag == 0:
                #global変数（dir, colNames, rowNames)を設定
                self.setGlobalValue()
                #popupmenuを表示
                self.grid_1.PopupMenu(self.popupFieldMenu, pos)
        event.Skip()


    #popupMenu初期化（label）
    def setLabelPopupMenu(self):
        self.popupLabelMenu = wx.Menu()
        for text in [u"patch名変更", u"patch削除"]:
            item = self.popupLabelMenu.Append(-1, text)
            self.Bind(wx.EVT_MENU, self.OnPopLabelItemSelected, item)

    #popupMenu初期化（field）
    def setFieldPopupMenu(self):
        self.popupFieldMenu = wx.Menu()
        for text in [u"全field表示", u"選択したfieldを非表示",
                      u"field表示順変更", "-", u"fieldコピー",
                      u"field貼付(挿入)", "-", u"field名変更", u"field削除"]:
            if text == "-":
                self.popupFieldMenu.AppendSeparator()
            else:
                item = self.popupFieldMenu.Append(-1, text)
                self.Bind(wx.EVT_MENU, self.OnPopupFieldItemSelected, item)

    #popupMenu実行
    def OnPopLabelItemSelected(self, event):
        global delPatchName, rowNames
        PPitem = self.popupLabelMenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        #patch名変更
        if text == u"patch名変更":
            self.onRenamePatchName(event)
        #patch削除
        elif text == u"patch削除":
            self.onDeletePatch(event)

    def OnPopupFieldItemSelected(self, event):
        PPitem = self.popupFieldMenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        #field非表示
        if text == u"選択したfieldを非表示":
            self.onNonDisplayFields(event)
        #field再表示、表示順変更
        elif text == u"field表示順変更":
            self.onHideDisplayFields(event)
        #表示設定クリア、全field表示
        elif text == u"全field表示":
            self.onDisplayAllFields(event)
        #fieldコピー
        elif text == u"fieldコピー":
            self.onCopyFields(event)
        #field貼付(挿入)
        elif text == u"field貼付(挿入)":
            self.onPasteFields(event)
        #field名変更
        elif text == u"field名変更":
            self.onRenameField(event)
        #field削除
        elif text == u"field削除":
            self.onDeleteFields(event)


    #
    #  onDeleteFields
    #    fieldの削除
    def onDeleteFields(self, event):
        global data, boundaryDir, colNames, dataDir, curCol
        selCol = self.grid_1.GetSelectedCols()
        colNo = []
        delFieldDir = []
        for n in selCol:
            colNo.append(n-1)
            delFieldDir.append(dataDir + "/" + colNames[n-1])
        #field削除の確認メッセージ
        title = u"fieldの削除"
        mess = u"次のfieldをゴミ箱へ移動します。\n"
        for n in colNo:
            mess += colNames[n] + ", "
        mess = mess[:-1]
        ans = self.okCancelDialog(title, mess)
        if ans != "OK":
            return
        #field削除
        i=0
        while i<len(delFieldDir):
            #ファイルをゴミ箱へ移動
            obj = gio.File(delFieldDir[i])
            obj.trash()
            i += 1
        #grid再表示
        newColNames = []
        i=0
        while i<len(colNames):
            flag = 0
            for n in colNo:
                if i == n:
                    flag = 1
                    break
            if flag == 0:
                newColNames.append(colNames[i])
            i += 1
        colNames = newColNames
        fileName = getSaveDisplayFieldsFileName(dataDir)
        if len(glob.glob(fileName)) != 0:
            dispNames = getDisplayFields(fileName)
            newDispNames = []
            i=0
            while i<len(dispNames):
                for name in colNames:
                    if dispNames[i] == name:
                        newDispNames.append(name)
                        break
                i += 1
            saveDisplayFields(newDispNames, dataDir)
        self.readDataMakeGrid()

    #
    #  onRenameField
    #    field名を変更する
    def onRenameField(self, event):
        global data, boundaryDir, colNames, dataDir, curCol
        selCol = self.grid_1.GetSelectedCols()
        if len(selCol) != 1:
            title = u"エラー"
            mess = u"複数のfieldは選択しないでください。\n1個のfieldを選択して、field名を変更してください"
            self.errDialog(title, mess)
            return
        colNo = selCol[0] - 1
        title = u"field名の変更"
        message = u"新しいfield名を入力してください"
        defText = colNames[colNo]
        #field名のチェック
        flag = 0
        while flag == 0:
            newName = self.textDialog(title, message, defText)
            if newName == "":
                flag = 1
            else:
                sameName = 0
                for name in colNames:
                    if name == newName:
                        sameName = 1
                        break
                if sameName == 0:
                    flag = 1
                else:
                    message = u"同じ名前のfieldがあります。再入力してください。"
                    defText = newName
        if newName == "":
            return
        #field名の変更
        oldDir = dataDir + "/" + colNames[colNo]
        newDir = dataDir + "/" + newName
        comm = "mv " + oldDir + " " + newDir
        print comm
        os.system(comm)
        #grid表示
        colNames[colNo] = newName
        self.readDataMakeGrid()

    #
    #  onPasteFields
    #    fieldの貼付（挿入）
    def onPasteFields(self, event):
        global data, boundaryDir, colNames, dataDir, curCol
        #pasteFieldsDir,Nameを取得
        f=open(clipBoard); contents=f.readlines(); f.close()
        pasteFieldsDir = []
        pasteFieldsName = []
        for fieldDir in contents:
            name = fieldDir[:-1].split("/")[-1]
            pasteFieldsName.append(name)
            pasteFieldsDir.append(fieldDir[:-(len(name)+1)])
        #貼り付けるデータが正しいデータかどうかをチェック
        i=0
        while i<len(pasteFieldsName):
            pasteDir = pasteFieldsDir[i] + pasteFieldsName[i]
            mess = ""
            if len(glob.glob(pasteDir)) == 0:
                title = u"エラー"
                mess = u"貼り付けるデータが間違っています。\n貼付を中止します。"
                self.errDialog(title, mess)
                break
            i += 1
        if mess != "":
            return
        #fieldNameのチェック
        [folders, fields] = pyTreeFoam.getFoldersFiles(dataDir)
        newPasteName = []
        n=0
        for pasteName in pasteFieldsName:
            i = 0; flag = 0
            newName = pasteName
            while flag == 0 and i<=10:
                sameName = 0
                for field in fields:
                    if field == newName:
                        newName = pasteName + "_copy" + str(i)
                        i += 1
                        sameName = 1
                        break
                if sameName == 0:
                    flag = 1                #loop脱出
            newPasteName.append(dataDir + "/" + newName)
            n += 1
        if i>10:
            title = u"エラー"
            mess = u"fieldを貼り付ける事ができません"
            self.errDialog(title, mess)
            return
        #fieldを貼り付ける
        i=0
        while i<len(pasteFieldsName):
            copyName = pasteFieldsDir[i] + pasteFieldsName[i]
            pasteName = newPasteName[i]
            comm = "cp " + copyName + " " + pasteName
            os.system(comm)
            i += 1
        print "paste --->", pasteName
        #grid再表示
        fileName = getSaveDisplayFieldsFileName(dataDir)
        if len(glob.glob(fileName)) == 0:
            for nameDir in newPasteName:
                colNames.append(nameDir.split("/")[-1])
            colNames.sort()
            self.readDataMakeGrid()
        else:
            dispNames = getDisplayFields(fileName)
            selCols = self.grid_1.GetSelectedCols()
            insCol = selCols[0]
            i=0; newNames =[]
            while i<insCol:
                newNames.append(dispNames[i])
                i += 1
            for nameDir in newPasteName:
                newNames.append(nameDir.split("/")[-1])
            while i<len(dispNames):
                newNames.append(dispNames[i])
                i += 1
            saveDisplayFields(newNames, dataDir)
            colNames = newNames
            self.readDataMakeGrid()

    #
    #  onCopyField
    #    fieldのコピー
    def onCopyFields(self, event):
        global data, boundaryDir, colNames, dataDir, curCol
        copyFields = []
        #選択範囲の先頭を取得
        [selRow, selCol] = self.getFirstSelectCell()
        if selRow < 0:
            #選択されていない場合は、cuurentCellを選択
            copyFields.append(curCol)
        else:
            #選択範囲を取得
            maxCol = self.grid_1.GetNumberCols()
            col = selCol
            while col<maxCol:
                if self.grid_1.IsInSelection(selRow, col) == True:
                    copyFields.append(col)
                col += 1
        #非表示列が0列かどうかチェック
        if copyFields[0] == 0:
            copyFields = copyFields[1:]
        if len(copyFields) == 0:
            title = u"エラー"
            mess = u"fieldが選択されていません"
            self.errDialog(title, mess)
            return
        #copyFieldDirを取得
        copyFieldDir = []
        for fieldNo in copyFields:
            copyFieldDir.append(dataDir + "/" + colNames[fieldNo-1])
        #clipBoardに保存
        print "copy-->",copyFieldDir
        f=open(clipBoard, "w")
        for val in copyFieldDir:
            f.write(val + "\n")
        f.close()

    #
    #  onDeletePatch
    #    patchの削除
    def onDeletePatch(self, event):
        global delPatchName, rowNames
        #cellの変更内容をチェック
        if self.checkEditedFlag() == 1:
            #cell修正
            title = u"警告"
            mess = u"cell内容が変更されています。\nこのまま継続すると変更内容が失われます。\n　　継続しますか？"
            ans = self.okCancelDialog(title, mess)
            if ans != "OK":
                return
        #global変数（dir, colNames, rowNames）を設定
        self.setGlobalValue()
        #削除するpatch名を取得
        selRows = self.grid_1.GetSelectedRows()
        if len(selRows) == 1 and selRows[0] > 1:
            row = selRows[0]
            delPatchName = rowNames[row-2]
            #patch削除
            title = u"patchの削除"
            mess = u"patch「" + delPatchName + u"」を削除します。\n\n　　削除後は、元に戻せません。"
            ans = self.okCancelDialog(title, mess)
            if ans == "OK":
                mess = u"本当に削除しますか？\n  削除後は元に戻りません。"
                ans = self.okCancelDialog(title, mess)
                if ans == "OK":
                    #patchを削除
                    error = deletePatch(delPatchName)
                    if error[0] != "OK":
                        #エラー処理
                        title = "エラー"
                        mess = error[1]
                        self.errDialog(title, mess)
                    else:
                        self.onReload(event)
        else:
            if len(selRows) == 0:
                mess = u"行を選択していません。\n\npatch名（ラベル部）をクリックして行を選択してください。"
            elif len(selRows) > 1:
                mess = u"複数行を選択しています。\n\n1行を選択してください。"
            elif selRows[0] <= 1:
                mess = u"patch名の行を選択してください。"
            self.errDialog(u"エラー", mess)

    #
    #  onRenamePatchName
    #    patch名の変更
    def onRenamePatchName(self, event):
        global delPatchName, rowNames
        #cellの変更内容をチェック
        if self.checkEditedFlag() == 1:
            #cell修正
            title = u"警告"
            mess = u"cell内容が変更されています。\nこのまま継続すると変更内容が失われます。\n　　継続しますか？"
            ans = self.okCancelDialog(title, mess)
            if ans != "OK":
                return
        #global変数（dir, colNames, rowNames）を設定
        self.setGlobalValue()
        #削除するpatch名を取得
        selRows = self.grid_1.GetSelectedRows()
        if len(selRows) == 1:
            row = selRows[0]
            if row > 1:
                delPatchName = rowNames[row-2]
                #patch名変更
                title = u"patch名変更"
                message = u"patch名を変更します"
                defText = delPatchName
                newPatchName = self.textDialog(title, message, defText)
                if (newPatchName != "") and (newPatchName != delPatchName):
                    for patchName in rowNames:
                        error = ["OK", ""]
                        if patchName == newPatchName:
                            error = ["NG",
                                     u"「" + newPatchName + u"」は同じpatch名が存在します"]
                            break
                    if error[0] != "OK":
                        #エラー表示
                        self.errDialog(u"エラー", error[1])
                    else:
                        #patch名を変更
                        error = changePatchName(delPatchName, newPatchName)
                        if error[0] != "OK":
                            self.errDialog(u"エラー", error[1])
                        else:
                            self.onReload(event)
            else:
                mess = u"patch名の行を選択してください。"
                self.errDialog(u"エラー", mess)    
        else:
            title = u"エラー"
            if len(selRows) > 1:
                mess = u"複数行を選択しています。\n\n1行を選択してください。"
            else:
                mess = u"行を選択していません。\n\npatch名（ラベル部）をクリックして行を選択してください。"
            self.errDialog(title, mess)

    #
    #  onDisplayAllFields
    #    表示設定クリア、全field表示
    def onDisplayAllFields(self, event):
        global colNames
        self.setGlobalValue()
        fileName = getSaveDisplayFieldsFileName(dataDir)
        if len(glob.glob(fileName)) == 0:
            title = u"全fieldの表示"
            mess = u"既に全fieldが表示されています。"
            self.okDialog(title, mess)
        else:
            title = u"全filedの表示"
            mess = u"非表示設定ファイルをクリアして、全fieldを再読込します。"
            ans = self.okCancelDialog(title, mess)
            if ans == "OK":
                comm = "rm " + fileName
                os.system(comm)
                [folders, fields] = pyTreeFoam.getFoldersFiles(dataDir)
                colNames = fields
                self.readDataMakeGrid()
                

    #
    #  onNonDisplayFields
    #    選択したfieldを非表示
    def onNonDisplayFields(self, event):
        global data, boundaryDir, rowNames, colNames, dataDir
        self.setGlobalValue()
        nonDisplayFields = []
        #選択範囲の先頭を取得
        [selRow, selCol] = self.getFirstSelectCell()
        if selRow < 0:
            #選択されていない場合は、cuurentCellを選択
            nonDisplayFields.append(curCol)
        else:
            #選択範囲を取得
            maxCol = self.grid_1.GetNumberCols()
            col = selCol
            while col<maxCol:
                if self.grid_1.IsInSelection(selRow, col) == True:
                    nonDisplayFields.append(col)
                col += 1
        #非表示列が0列かどうかチェック
        if nonDisplayFields[0] == 0:
            nonDisplayFields = nonDisplayFields[1:]
        #colNamesを修正
        newColNames = []
        i = 0
        while i < len(colNames):
            flag = 0
            for j in nonDisplayFields:
                if (i == j-1):
                    flag = 1
            if flag == 0:
                newColNames.append(colNames[i])
            i += 1
        colNames = newColNames
        #fieldの非表示
        i=len(nonDisplayFields)
        while i>0:
            i -= 1
            col = nonDisplayFields[i]
            self.grid_1.DeleteCols(col, 1)
        #項目を再セット
        self.grid_1.SetColLabelValue(0, "define patch\n(boundary)")
        i=1
        for item in colNames:
            self.grid_1.SetColLabelValue(i, item)
            i+=1
        #表示設定ファイル有無確認
        self.checkDisplayFieldsFile(dataDir)
        #非表示設定を保存
        saveDisplayFields(colNames, dataDir)
        self.setLabelColour(dataDir)

    #
    #  onHideDisplayFields
    #    Fieldの非表示、表示、表示順の設定
    def onHideDisplayFields(self, event):
        global colNames, dataDir
        self.setGlobalValue()
        [folders, fields] = pyTreeFoam.getFoldersFiles(dataDir)
        hideNames = []
        for field in fields:
            flag = 0
            for showName in colNames:
                if showName == field:
                    flag = 1
                    break
            if flag == 0:
                hideNames.append(field)
        hideNames.sort()
        openFieldForGridEditorDDialog.hideNames = hideNames
        openFieldForGridEditorDDialog.colNames = colNames
        dialog = openFieldForGridEditorDDialog.MyDialog(None)
        result = dialog.ShowModal()
        ans = openFieldForGridEditorDDialog.status
        dialog.Destroy()
        if ans == "OK":
            colNames = openFieldForGridEditorDDialog.colNames
            #表示設定ファイル有無確認
            self.checkDisplayFieldsFile(dataDir)
            #非表示設定を保存
            saveDisplayFields(colNames, dataDir)
            #grid再作成
            self.readDataMakeGrid()


    def checkDisplayFieldsFile(self, dataDir):
        fileName = getSaveDisplayFieldsFileName(dataDir)
        if len(glob.glob(fileName)) == 0:
            title = u"表示field設定ファイルの作成"
            mess = u"非表示、表示fieldの設定ファイルを作成しました。\n"
            mess += u"  設定した内容は、次回のGridEditor起動時に反映されます。"
            self.okDialog(title, mess)
            

    #
    #  readDataMakeGrid
    #    cellデータを読込み、gridを再作成する
    def readDataMakeGrid(self):
        global data
        data = self.loadFromGaugeDialog(dataDir, colNames, rowNames)
        self.checkBadField(colNames, data)
        #Grid再作成
        title = self.GetTitle()
        self.initializeGridSize()           #（1x1）のgridに設定
        self.SetTitle(title)
        self.createMatrix()
        self.setMatrixData()
        self.grid_1.AutoSize()
        self.clearStatus()
        self.Layout()
        self.setLabelColour(dataDir)



    #
    #  loadFromGaugeDialog(dataDir, colNames, rowNames)
    #    gaugeDialogからデータを取得する
    def loadFromGaugeDialog(self, dataDir, colNames, rowNames):
        gaugeDDialog.job = "load"
        gaugeDDialog.title = u"fieldの読み込み"
        gaugeDDialog.dataDir = dataDir
        gaugeDDialog.colNames = colNames
        gaugeDDialog.rowNames = rowNames
        gaugeDDialog.maxRowsInCell = maxRowsInCell      #cell内の最大表示行数を設定
        dialog = gaugeDDialog.MyDialog(None)
        result = dialog.ShowModal()
        ans = gaugeDDialog.status
        dialog.Destroy()
        if ans == "OK":
            data = gaugeDDialog.data
        else:
            #読み込みをキャンセルした場合
            data = []
            col = 0; row = 0
            while col < len(colNames):
                dataCol = []
                while row < len(rowNames):
                    dataCol.append("")
                    row += 1
                data.append(dataCol)
                col += 1
        return data

    #
    #  saveAtGaugeDialog
    #    gaugeDialogを通してデータを保存する
    def saveAtGaugeDialog(self, dataDir, colNames, rowNames, cellData, intData):
        gaugeDDialog.job = "save"
        gaugeDDialog.title = u"fieldの保存"
        gaugeDDialog.dataDir = dataDir
        gaugeDDialog.colNames = colNames
        gaugeDDialog.rowNames = rowNames
        gaugeDDialog.intData = intData
        gaugeDDialog.data = cellData
        dialog = gaugeDDialog.MyDialog(None)
        reult = dialog.ShowModal()
        ans = gaugeDDialog.status
        error = gaugeDDialog.error
        dialog.Destroy()
        if error[0] != "OK":
            title = u"エラー"
            mess = error[1]
            self.errDialog(title, mess)
        if ans == "OK":
            return
        else:
            #保存をキャンセルした場合
            title = u"保存の中止"
            mess = u"保存を中止しました"
            self.okDialog(title, mess)
        return

    # saveCSV
    #  CSV形式で保存する
    def saveCSV(self):
        global dataDir
        print "csv形式で保存します。"
        dialog = saveCSV_dialog.MyDialog(None)
        result = dialog.ShowModal()
        ans = saveCSV_dialog.status
        csvName = saveCSV_dialog.fileName
        dialog.Destroy()
        if ans == "OK" and len(csvName) > 0:
            if not (csvName[-4:] == ".csv" or csvName[-4:] == ".CSV"):
                csvName += ".csv"
            maxRow = self.grid_1.GetNumberRows()
            maxCol = self.grid_1.GetNumberCols()
            #cellデータ取得
            data = []
            row = 0
            while row < maxRow:
                col = 0
                line = []
                while col < maxCol:
                    line.append(self.grid_1.GetCellValue(row, col))
                    col += 1
                data.append(line)
                row += 1
            #rowName取得
            row = 0
            rowName = []
            while row < maxRow:
                rowName.append(self.grid_1.GetRowLabelValue(row))
                row += 1
            #colName取得
            col = 0
            colName = []
            while col < maxCol:
                colName.append(self.grid_1.GetColLabelValue(col))
                col += 1
            #csvデータ作成
            csvData = []
            #1行目（field名）作成
            line = u'""'
            col = 0
            while col < maxCol:
                line += ',"' + colName[col] + '"'
                col += 1
            line += '\n'
            csvData.append(line)
            #内部データ作成（patch名含む）
            row = 0
            while row < maxRow:
                line = '"' + rowName[row] + '"'
                col = 0
                while col < maxCol:
                    line += ',"' + data[row][col] + '"'
                    col += 1
                line += '\n'
                csvData.append(line)
                row += 1
            #保存
            res = "OK"
            if len(glob.glob(csvName)) != 0:
                title = u"csv保存"
                message = u"「" + csvName + u"」は、既に存在しています。\n　書き換えますか？"
                res = self.okCancelDialog(title, message)
            if res == "OK":
                f=open(csvName, "w")
                for line in csvData:
                    f.write(line)
                f.close()
                title = u"csv保存"
                message = u"boundaryFieldをcsv形式で保存しました。"
                self.okDialog(title, message)
        #エラー
        else:
            if len(csvName) == 0:
                title = u"エラー"
                message = u"ファイル名が入力されていません。"
                self.errDialog(title, message)
            

    #  getCopyValue
    #    コピーするデータをcopyValuesに入れる
    def getCopyValues(self):
        global copyValues, copyRow, copyCol
        #選択範囲の先頭を取得
        [copyRow, copyCol] = self.getFirstSelectCell()
        if copyRow < 0:
            #選択範囲が設定されていない場合は、currentCellをコピー
            value = self.grid_1.GetCellValue(curRow, curCol)
            copyValues = [[value]]
        else:
            #選択範囲の値を取得
            maxRow = self.grid_1.GetNumberRows()
            maxCol = self.grid_1.GetNumberCols()
            copyValues=[]
            row = copyRow
            while row<maxRow:
                rowVal = []
                col = copyCol
                flag = 0
                while col<maxCol:
                    if self.grid_1.IsInSelection(row, col) == True:
                        value = self.grid_1.GetCellValue(row, col)
                        rowVal.append(value)
                        flag = 1
                    col+=1
                #行内に選択範囲があればその行を保存、無ければ終了
                if flag == 1:
                    copyValues.append(rowVal)
                else:
                    row = maxRow        #終了
                row+=1
        #clipBoardに保存
        print "copy-->",copyValues
        f=open(clipBoard, "w")
        for rowVal in copyValues:
            for val in rowVal:
                f.write(val + "\b")
            f.write("\a")
        f.close()



    #  pasteCopyValues
    #    コピーで取得したデータを貼り付ける
    def pasteCopyValues(self):
        global copyValues, curRow, curCol
        #保存フラグをセット
        self.alarmSaveFlagSet()
        #clipBoardから読み込み
        f=open(clipBoard)
        val = ""
        rowVal = []
        copyVals = []
        chara = f.read(1)
        while chara != "":
            if chara == "\b":
                rowVal.append(val)
                val = ""
            elif chara == "\a":
                copyVals.append(rowVal)
                rowVal = []
            else:
                val += chara
            chara = f.read(1)
        print "paste-->",copyVals
        copyValues = copyVals

        maxRow = self.grid_1.GetNumberRows()
        maxCol = self.grid_1.GetNumberCols()
        #コピー先の選択範囲をチェック
        [row, col] = self.getFirstSelectCell()
        if row>=0:
            #選択範囲の先頭をコピー先に指定
            [lastRow, lastCol] = self.getLastSelectCell(row, col)
            copRow = row
            copCol = col
            #コピー開始
            row = copRow
            i=0; j=0
            while row <= lastRow:
                col = copCol
                while col <= lastCol:
                    [copVal, copyValues, i, j] = self.getCopyValueForCell(copyValues, i, j)
                    self.grid_1.SetCellValue(row, col, copVal)
                    col += 1
                row += 1            
        else:
            #current位置をコピー先に指定
            copRow = curRow
            copCol = curCol
            #コピー開始
            row = copRow
            for rowVal in copyValues:
                col = copCol
                for value in rowVal:
                    if row<maxRow and col<maxCol:
                        self.grid_1.SetCellValue(row, col, value)
                    col+=1
                row+=1

    def getCopyValueForCell(self, copyValues, i, j):
        value = copyValues[i][j]
        j+=1
        if j >= len(copyValues[i]):
            j=0
            i+=1
            if i>= len(copyValues):
                i=0
        return [value, copyValues, i, j]

    #  getFirstSelectCell
    #    選択範囲の先頭cell位置を返す
    #    選択されていない場合は、-1が返る
    def getFirstSelectCell(self):
        #選択範囲の先頭を取得
        maxRow = self.grid_1.GetNumberRows()
        maxCol = self.grid_1.GetNumberCols()
        selRow = 0
        selCol = 0
        flag = 0
        row = 0
        while row<maxRow:
            col = 0
            while col<maxCol:
                if self.grid_1.IsInSelection(row, col) == True:
                    selRow = row; selCol = col
                    row = maxRow; col = maxCol
                    flag = 1
                col+=1
            row+=1
        if flag == 0:
            #選択されていない場合
            selRow = -1; selCol = -1
        return [selRow, selCol]

    #  getLastSelectCell
    #    選択範囲の最終cell位置を返す
    #　　選択されていない場合は、-1が返る
    def getLastSelectCell(self, iniRow, iniCol):
        maxRow = self.grid_1.GetNumberRows()
        maxCol = self.grid_1.GetNumberCols()
        row = iniRow
        while row<maxRow and self.grid_1.IsInSelection(row, iniCol)==True:
            row += 1
        lastRow = row -1
        col = iniCol
        while col<maxCol and self.grid_1.IsInSelection(iniRow, col)==True:
            col += 1
        lastCol = col -1
        return [lastRow, lastCol]

    #  setGlobalValue
    #    global変数（dir, colNames, rowNames）をセット
    #　　multiTaskの場合、global変数が信用できなくなる為、処理の直前で設定できる様にする為
    #    上記以外のglobal変数は、基本的に読み込むので不要
    def setGlobalValue(self):
        global boundaryDir, dataDir, colNames, rowNames
        #dirの取得
        [boundaryDir, dataDir] = self.getDirectoryFromGrid()
        #colNmes（fields）の取得
        maxCol = self.grid_1.GetNumberCols()
        fields = []
        col=1
        row=0
        while col<maxCol:
            fields.append(self.grid_1.GetColLabelValue(col))
            col+=1
        colNames = fields
        #rowNames（patches）の取得
        maxRow = self.grid_1.GetNumberRows()
        patches = []
        row = 2
        while row<maxRow:
            patch = self.grid_1.GetRowLabelValue(row)
            patch = string.join(patch.split("\n"), "")
            patches.append(patch)
            row+=1
        rowNames = patches

    #
    #  getDirectoryFromGrid
    #    gridからDirectoryを取得
    #    戻り値:[bondaryDir, dataDir]
    def getDirectoryFromGrid(self):
        gridNo = (((self.GetTitle()).split("("))[1].split(")")[0])
        #gridList = treefoam.gridNo
        gridList = getGridList()
        bondDir = ""
        dataDir = ""
        for cont in gridList:
            if gridNo == cont[0]:
                bondDir = cont[1]
                dataDir = cont[2]
                break
        if bondDir=="" or dataDir=="":
            title = u"エラー"
            mess = u"gridに対応するdirが取得できません。"
            print mess
            self.errDialog(title, mess)
        return [bondDir, dataDir]

    #
    #  initializeGridSize
    #    gridの初期化（1x1）のgridに設定
    def initializeGridSize(self):
        #既にある表を（1x1）の表に設定すると、見かけ上（1x1）になるだけで
        #「self.grid_1.GetNumberRows()」で取得した行数は変わらないので注意。
        """
        self.grid_1.DeleteRows(pos, delRows-1)
        self.grid_1.DeleteCols(pos, delCols)
        """
        self.grid_1.CreateGrid(1, 1)
        self.grid_1.SetCellValue(0, 0, "")      #cellを空白に設定

    #  createMatrix
    #    matrixデータからGridを作成する
    def createMatrix(self):
        #row,colを作成
        rowLabelSize = 100.0        #rowLabelの幅
        colLabelSize = 40.0         #colLabelの高さ
        self.grid_1.SetRowLabelSize(rowLabelSize)
        self.grid_1.SetColLabelSize(colLabelSize)
        #表の大きさを合わせる
        if self.grid_1.GetNumberRows() < len(rowNames)+2:
            self.grid_1.AppendRows((len(rowNames)+2) - (self.grid_1.GetNumberRows()))
        elif self.grid_1.GetNumberRows() > len(rowNames)+2:
            self.grid_1.DeleteRows(0, self.grid_1.GetNumberRows()-(len(rowNames)+2))
        if self.grid_1.GetNumberCols() < len(colNames)+1:
            self.grid_1.AppendCols((len(colNames)+1) - (self.grid_1.GetNumberCols()))
        elif self.grid_1.GetNumberCols() > len(colNames)+1:
            self.grid_1.DeleteCols(0, self.grid_1.GetNumberCols()-(len(colNames)+1))
        #editorをセット（全てmultiLineEditorにセット）
        row=0
        while row<len(rowNames)+2:
            col=0
            while col<len(colNames)+1:
                self.grid_1.SetCellEditor(
                    row, col, wx.grid.GridCellAutoWrapStringEditor())
                col += 1
            row += 1
        #2行1列に色をつける
        attr = wx.grid.GridCellAttr()
        attr.SetBackgroundColour("yellow")
        self.grid_1.SetRowAttr(1, attr)
        self.grid_1.SetColAttr(0, attr)
        self.grid_1.SetCellBackgroundColour(1, 0, "yellow")
        maxCol = self.grid_1.GetNumberCols()
        col = 0
        while col < maxCol:
            self.grid_1.SetCellBackgroundColour(0, col, "pink") 
            col+=1
        #項目をセット（行名)
        self.grid_1.SetRowLabelValue(0, "field type\ndimensions")
        self.grid_1.SetRowLabelValue(1, "internal\nField")
        rowLabels = line2lines(rowNames, 10)
        i=2
        for rowLabel in rowLabels:
            self.grid_1.SetRowLabelValue(i, rowLabel)
            i+=1
        #項目をセット（列名）
        self.grid_1.SetColLabelValue(0, "define patch\n(boundary)")
        i=1
        for item in colNames:
            self.grid_1.SetColLabelValue(i, item)
            i+=1
        

    #  setMatrixData
    #    gridにデータセット
    def setMatrixData(self):
        global boundaryDir, dataDir, rowNames, colNames, data
        #  0列にpatch定義データのセット
        defineData = getDefinePatchData(boundaryDir, rowNames)
        col=0
        i=0
        while i<len(defineData):
            row = i + 2
            lines = defineData[i].split("\n")
            subData = []
            flag = 0
            for line in lines:
                lineData = line.split(";")
                words = lineData[0].split()
                if len(words) > 1:
                    if words[0] != "nFaces" and words[0] != "startFace":
                        subData.append(line)
                    if words[0] == "nFaces" and words[1] == "0":
                        flag = 1
                if len(words) == 1:
                    subData.append(line)
            if len(lines) > 0:
                lines = string.join(subData, "\n")
            self.grid_1.SetCellValue(row, col, lines)
            if flag == 1:
                #self.grid_1.SelectRow(row)
                self.grid_1.SetCellFont(row, col,  wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "VL ゴシック"))
                maxCol = self.grid_1.GetNumberCols()
                coll = 0
                while coll < maxCol:
                    self.grid_1.SetCellBackgroundColour(row, coll, "yellow")
                    coll+=1
            i+=1
        #  1列以降にデータをセット
        col=1
        for labels in data:
            i = 0
            while i<len(labels):
                row = i + 2
                self.grid_1.SetCellValue(row, col, labels[i])
                i+=1 
            col+=1
        #  0行にデータ（dimensions）をセット
        dimData = getDimensionsData(dataDir, colNames)
        row = 0
        col = 1
        for value in dimData:
            if len(value) != 0:
                self.grid_1.SetCellValue(row, col, value)
            col += 1
        #  1行にデータ（internalField）をセット
        intData = getInternalFieldData(dataDir, colNames)
        row = 1
        col = 1
        for value in intData:
            self.grid_1.SetCellValue(row, col, value)
            col+=1
        self.setLabelColour(dataDir)


    def setLabelColour(self, dataDir):
        #field非表示設定ファイルの有無チェック
        fileName = getSaveDisplayFieldsFileName(dataDir)
        if len(glob.glob(fileName)) != 0:
            #ラベル色をdarkblueにセット
            self.grid_1.SetLabelTextColour("darkblue")
        else:
            #ラベル色をblackにセット
            self.grid_1.SetLabelTextColour("black")



    #
    #  getAllFieldCellsData
    #    全cell内のデータを取得
    def getAllFieldCellsData(self):
        fpatches = []
        col = 1
        while col<len(colNames)+1:
            row = 2
            fpatch = []
            while row<len(rowNames)+2:
                patch = rowNames[row-2]
                value = self.grid_1.GetCellValue(row, col)
                if value != "":
                    value = self.reformPatchContents(value)
                fpatch.append(value)
                row+=1
            fpatches.append(fpatch)
            col+=1
        return fpatches

    #
    #  getDefineCellData
    #    patchの定義データ(boundary)をcellから取得
    def getDefineCellData(self):
        defineData = []
        col = 0
        row = 2
        while row<len(rowNames)+2:
            value = self.grid_1.GetCellValue(row, col)
            if value != "":
                value = self.reformPatchContents(value)
            defineData.append(value)
            row+=1
        return defineData

    #
    #  getInternalFieldCellData
    #    internalFieldデータをcellから取得
    def getInternalFieldCellData(self):
        intData = []
        row = 1
        i=0
        while i<len(colNames):
            col = i + 1
            value = self.grid_1.GetCellValue(row, col)
            if value != "":
                value = self.reformInternalData(value)
            intData.append(value)
            i+=1
        return intData

    #
    #  reformInternalData
    #    internalFieldデータを整形
    #    uniform以外は""に設定
    def reformInternalData(self, value):
        tab2 = 19
        words = value.split()
        line = ""
        if len(words)>1:
            if words[0] == "uniform":
                line += "internalField"
                if len(line) < tab2:
                    line += (tab2-len(line))*" "
                else:
                    line += " "
                line += string.join(words[0:], " ") + "\n"
            else:
                line = ""
        else:
            line = ""
        return line

    #
    #  reformPatchContents
    #    patch内容を整形
    def reformPatchContents(self, value):
        #行頭に空白追加
        words = value.split("\n")
        i=0
        while i<len(words):
            wds = words[i].split()
            if len(wds) > 1:
                wds[0] = "        " + wds[0]
                if len(wds[0])<19:
                    j=len(wds[0])
                    while j<19:
                        wds[0] += " "
                        j+=1
                words[i] = wds[0] + " " + string.join(wds[1:], " ")
            elif len(wds) == 1:
                words[i] = wds[0]
            #words[i] = "        " + words[i]
            i+=1
        value = string.join(words, "\n") + "\n"
        return value

    #
    #  replaceBoundaryData
    #
    def replaceBoundaryData(self, fields, cellData, intData):
        global rowNames, dataDir
        patches = []
        for patch in rowNames:
            patches.append("    " + patch)
        #print patches
        error = pyTreeFoam.setFieldsPatchesName(
                    dataDir, fields, patches, cellData, intData)
        return error

    #
    #  replaceDefineData
    #
    def replaceDefineData(self, cellData):
        global rowNames, boundaryDir
        patches = []
        for patch in rowNames:
            patches.append("    " + patch)
        error = pyTreeFoam.setBoundaryData(boundaryDir, patches, cellData)
        return error


    #  checkBadField
    #    patchDataのチェック、エラー表示
    def checkBadField(self, fields, patchData):
        i=0; badFields=[]
        while i<len(fields):
            flag = 0
            for bpData in patchData[i]:
                if bpData == "":
                    flag = 1
                    badFields.append(fields[i])
                    break
            i+=1
        if len(badFields) > 0:
            title = u"エラー"
            mess = u"「" + string.join(badFields, ",") + u"」のfieldが正しく読み込めていません。"
            self.errDialog(title, mess)

    def clearStatus(self):
        self.frame_1_statusbar.SetStatusText("")

    def checkSaveFlag(self):
        if self.checkEditedFlag() == 0:
            return 0
        else:
            title = u"保存確認"
            mess = u"cell内容が変更されています。\n　　終了しますか？"
            ans = self.yesNoDialog(title, mess)
            if ans == "YES":
                return 0
            else:
                return 1

    def checkEditedFlag(self):
        alarmSaveFlag = self.GetTitle().split(":")[1][0]
        if alarmSaveFlag == " ":
            return 0            #修正無し
        else:
            return 1            #修正あり


    def alarmSaveFlagClear(self):
        title = self.GetTitle()
        currFlag = title.split(":")[1][0]
        if currFlag == " ":
            return
        else:
            newTitle = title.split(":")
            newTitle[1] = " " + newTitle[1][1:]
            self.SetTitle(":".join(newTitle))

    def alarmSaveFlagSet(self):
        title = self.GetTitle()
        currFlag = title.split(":")[1][0]
        if currFlag == "*":
            return
        else:
            newTitle = title.split(":")
            newTitle[1] = "*" + newTitle[1][1:]
            self.SetTitle(":".join(newTitle))


    #------------------
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        res = dlg.ShowModal()
        if res == wx.ID_OK:
            ans = "OK"
        else:
            ans = "CANCEL"
        dlg.Destroy()
        return ans

    def yesNoDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.YES | wx.NO | wx.ICON_INFORMATION) 
        res = dlg.ShowModal()
        if res == wx.ID_YES:
            ans = "YES"
        else:
            ans = "NO"
        dlg.Destroy()
        return ans


    def textDialog(self, title, message, defText):
        dlg = wx.TextEntryDialog(self, message, title, defaultValue=defText)
        ansBtn = dlg.ShowModal()
        ansTxt = dlg.GetValue()
        if ansBtn == wx.ID_OK:
            text = ansTxt
        else:
            text = ""
        return text

# end of class MyFrame


#
#  getPatchDataFromBoundaryFields
#    patchDataを取得
#    
def getPatchDataFromBoundaryFields(dataDir, fields, rowNames):
    #patchDataを各Fieldから取得
    [files, patchesF, patchData] = pyTreeFoam.getFieldsPatchesName_sub(dataDir, fields)
    #patchDataを修正
    data=[]; j=0
    for fieldPatch in patchData:
        fieldData=[]
        for patch in rowNames:
            i=0; flag=0
            while i<len(fieldPatch) and flag==0:
                if patch == patchesF[i]:
                    fieldData.append(fieldPatch[i])
                    flag = 1
                i += 1
            if flag == 0:
                fieldData.append("")
        data.append(fieldData)
        j += 1
    patchData = data
    #patchDataの文字数をチェック、修正
    data = []
    for field in patchData:
        i=0
        while i<len(field):
            #100文字以上の場合チェックする。
            if len(field[i]) > 100:
                patchCont = field[i][:1000].split("\n")
                #15行以上の場合は、15行に縮める。
                if len(patchCont) > 15:
                    field[i] = string.join(patchCont[:15], "\n")+"..."
            i+=1
        data.append(field)
    patchData = data
    return patchData

#
#  getRowNamesFromBoundary
#    rowNamesをbundaryから取得する。
def getRowNamesFromBoundary(boundaryDir):
    ans = []
    values = getFoamContents.getPatchNameFromBoundary(boundaryDir)
    for patchG in values:
        ans.append(patchG[0])
    return ans


#
#  changePatchName
#    patch名の変更
def changePatchName(oldPatchName, newPatchName):
    global boundaryDir, dataDir, colNames
    fields = pyTreeFoam.getFieldNames(dataDir)      #全てのfieldを取得
    error = pyTreeFoam.changePatchName(boundaryDir, dataDir, fields,
                                       oldPatchName, newPatchName)
    return error

#
#  line2lines
#    lineをlength幅で複数lineに分割
def line2lines(lines, length):
    ans = []
    for line in lines:
        j=0; n=length ;l=[]
        while len(line) > j*n:
            l.append(line[j*n:(j+1)*n]) 
            j+=1
        word = string.join(l,"\n")
        ans.append(word)
    return ans

#
#  deletePatch
#    patchを削除する
def deletePatch(delPatch):
    global boundaryDir, dataDir, colNames
    #fields = colNames
    fields = pyTreeFoam.getFieldNames(dataDir)      #全てのfieldを取得
    error = pyTreeFoam.deletePatch(boundaryDir, dataDir, fields, delPatch)
    return error

def getDefinePatchData(wdir, names):
    #boundaryの定義内容を取得
    fileName = wdir + "/boundary"
    f=open(fileName); contents=f.read(); f.close()
    defineD = []
    for keyword in names:
        [define, p] = getFoamContents.getKeywordContentsMem(
                keyword, contents, 0)
        defineD.append(define)
    #空白を詰める
    newDefine = []
    for define in defineD:
        newLines = []
        lines = define.split("\n")
        for line in lines:
            words = line.split()
            if len(words)>0:
                wd = string.join(words, " ")
                newLines.append(wd)
        if len(newLines)>0:
            newDefine.append(string.join(newLines, "\n"))
        else:
            newDefine.append("")
    return newDefine

def getDimensionsData(fieldDir, fields):
    dimData = []
    for field in fields:
        fileName = fieldDir + "/" + field

        dimW = []
        if len(glob.glob(fileName)) != 0:
            f=open(fileName); contents=f.read(); f.close()
            [dummy, p] = getFoamContents.getKeywordContentsMem(
                    "FoamFile", contents, 0)
            value = getKeywordValue("class", dummy, 0)
            dimW = value + "\n"
            value = getKeywordValue("dimensions", contents, p)
            if value == "":
                print field + u"のdimensionsが取得できません。"
            dimW += value

        dimData.append(dimW)
    return dimData

def getKeywordValue(searchW, contents, p):
        [keyword, p] = getFoamContents.getKeywordMem(contents, p)
        while keyword != searchW and keyword != "":
            [keyword, p] = getFoamContents.getKeywordMem(contents, p)
        if keyword != "":
            p=getFoamContents.skipSpaceMem(contents, p)
            pEnd = getFoamContents.skipUntilCRMem(contents, p)
            value = contents[p:pEnd]
        else:
            value = ""
        return value

def getInternalFieldData(fieldDir, fields):
    intData = []
    for field in fields:
        fileName = fieldDir + "/" + field
        if len(glob.glob(fileName)) != 0:
            f=open(fileName); contents=f.read(); f.close()
            [dummy, p] = getFoamContents.getKeywordContentsMem(
                    "FoamFile", contents, 0)
            [keyword, p] = getFoamContents.getKeywordMem(contents, p)
            while keyword != "internalField" and keyword != "":
                [keyword, p] = getFoamContents.getKeywordMem(contents, p)
            if keyword != "":
                intW = contents[p:p+100].split("\n")
                alist=(intW[0]).split()
                if alist[0] == "uniform":
                    a=string.join(alist, " ")
                    intData.append(a)
                else:
                    a = pyTreeFoam.compressSPCR(intW[0]) + "\n"
                    a += string.join(intW[1:5], "\n") + "..."
                    intData.append(a)
            else:
                print field + u"のinternalFieldのデータが取得できません。"
                intData.append("")
        else:
            intData.append("")
    return intData

#
#  endingGrid
#    終了処理
def endingGrid(title, gridSize, colNames, dataDir):
    #closeする前にgridNoを削除
    ownGridNoStr = title
    gridList = getGridList()
    [gridNoStr, p] = getFoamContents.getSmallPairMem(ownGridNoStr, 0)
    newGridList = []
    for grid in gridList:
        if (grid[0]) != (gridNoStr):
            newGridList.append(grid)
    saveGridList(newGridList)
    #windowSizeを保存
    saveGridSize(gridSize)

#
#  initializeGrid
#    初期化
def initializeGrid():
    #gridNoの取得
    global gridTitle, nTreeFoam, gridSize
    gridList = getGridList()
    if len(gridList) == 0:
        newGridNo = "0"
    else:
        currNo = "-1"
        for cont in gridList:
            treeFoamNo = cont[0].split(":")[0]
            gridNo = cont[0].split(":")[1]
            if nTreeFoam == treeFoamNo:
                currNo = gridNo
        newGridNo = str(int(currNo) + 1)
    newGridNoAbs = nTreeFoam + ":" + newGridNo
    newGrid = [newGridNoAbs, boundaryDir, dataDir]
    gridList.append(newGrid)
    saveGridList(gridList)
    gridTitle = gridTitle + " (" + newGridNoAbs + ")"
    #windowSizeの読み込み
    gridSize = getGridSize()


def getGridSize():
    global gridSize
    ans = gridSize
    fileName = os.environ["TreeFoamPath"] + "/winSize"
    if len(glob.glob(fileName)) != 0:
        f = open(fileName); lines = f.readlines(); f.close()
        for line in lines:
            words = line.split()
            if len(words) == 3:
                if words[0] == "gridEditor":
                    ans = (int(words[1]), int(words[2]))
    if ans[0] < 100 or ans[1] < 100:
        ans = gridSize
    return ans

def saveDisplayFieldsIfFile(colNames, dataDir):
    fileName = getSaveDisplayFieldsFileName(dataDir)
    if len(glob.glob(fileName)) != 0:
        saveDisplayFields(colNames, dataDir)

def saveDisplayFields(colNames, dataDir):
    fileName = getSaveDisplayFieldsFileName(dataDir)
    f=open(fileName, "w")
    for name in colNames:
        line = name + "\n"
        f.write(line)
    f.close()

def getSaveDisplayFieldsFileName(dataDir):
    dataDirList = dataDir.split("/")
    caseDir = ""
    subFolder = 0
    try:
        a = float(dataDirList[-1])
        caseDir = string.join(dataDirList[:-1], "/")
    except:
        caseDir = string.join(dataDirList[:-2], "/")
        subFolder = 1
    timeFolders = pyTreeFoam.getTimeFolders(caseDir)
    saveDir = caseDir + "/" + timeFolders[0]
    if subFolder == 1:
        saveDir += "/" + dataDirList[-1]
    fileName = saveDir + "/" + displayFieldsFile
    return fileName

def getDisplayFields(fileName):
    f=open(fileName)
    contents = f.read()
    f.close()
    fields = contents.split()
    return fields


def saveGridSize(gridSize):
    (h, w) = gridSize
    fileName = os.environ["TreeFoamPath"] + "/winSize"
    contents = []
    if len(glob.glob(fileName)) != 0:
        f=open(fileName); contents=f.readlines(); f.close()
        i=0
        for line in contents:
            words = line.split()
            if words[0] == "gridEditor":
                words[1] = str(h)
                words[2] = str(w)
                contents[i] = words[0] + " " + words[1] + " " + words[2] + "\n"
                break
            i += 1
    else:
        line = "gridEditor " + str(h) + " " + str(w) + "\n"
        contents.append(line)
    f=open(fileName, "w")
    for line in contents:
        f.write(line)
    f.close()

def getGridList():
    fileName = os.environ["TreeFoamPath"] + "/nRunningGrid"
    if len(glob.glob(fileName)) == 0:
        gridList = []
    else:
        gridList = []
        f=open(fileName); lines=f.readlines(); f.close()
        for line in lines:
            elements = line.split()
            if len(elements) > 0:
                gridList.append(line.split())
    return gridList

def saveGridList(gridList):
    fileName = os.environ["TreeFoamPath"] + "/nRunningGrid"
    f=open(fileName, "w")
    for cont in gridList:
        line = string.join(cont, " ") + "\n"
        f.write(line)
    f.close()



if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
