#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   mergeCellZones.py
#       setsフォルダ内に抜き出されたcellZoneファイルをmeargeする
#
#       使い方
#       meargeCellZones [cellZone_1 cellZone_2 ...]
#
#       10/03/21    新規作成
#

import sys
import os
import glob
import getFoamContents
import setFoamContents


#
#  getParameter
#    cellZoneNameを取得
def getParameter():
    cellZoneName = []
    commArg = sys.argv
    i=1
    while i < len(commArg):
        cellZoneName.append(commArg[i])
        i=i+1
    return cellZoneName

#
#  checkPrintHelp
#    helpを出力する。
def checkPrintHelp(cellZoneName):
    flag = ""
    for name in cellZoneName:
        if name[0] == "-":
            msg = "\n<使い方>\n"
            msg = msg + "mergeCellZone [option] <newName> <addedName...>\n"
            msg = msg + "複数のcellZoneをmergeして新しいcellZoneファイルをつくる。\n"
            print msg
            flag = "help"
    return flag

#
#  checkCellZoneName
#    入力したcellZoneNameをチェックする。
def checkCellZoneName(cellZoneName, cont):
    i=1
    while i < len(cellZoneName):
        n=0
        flag = "NG"
        while n < len(cont):
            if cellZoneName[i] == cont[n][0]:
                flag = "OK"
                n = len(cont)
            n=n+1
        if flag == "NG":
            badName = cellZoneName[i]
            i = len(cellZoneName)
        i=i+1
    error = []
    if flag == "NG":
        error.append(flag)
        error.append(badName)
        print "\n入力したcellZoneName:" + badName + " がcellZonesファイル内に定義されていません。\n　入力したcellZoneNameを確認してください。\n"
    else:
        if len(cellZoneName) <= 2:
            error.append("NG")
            error.append("number of names")
            print "\nmergeするcellZoneNameは、2ヶ以上必要です。\n"
        else:
            error.append(flag)
            error.append("")
    return error


# getOnlyCellNo
def getOnlyCellNo(cont):
    n=0; ans = []
    while len(cont[n][1]) != 0:
        value = []
        name = cont[n][0]
        allValue = getFoamContents.getValueInContents(0, "(", ")", cont[n][1])
        value.append(name)
        value.append(allValue[1][1])
        ans.append(value)
        n=n+1
    return ans

#
#  mergeCellNo
#
def mergeCellNo(cellName, cellValue):
    # mergeした結果を保存する名前を取得
    resultName = cellName[0]
    # mergeする名前を取得
    i=1; mergeName = []
    while i < len(cellName):
        mergeName.append(cellName[i])
        i=i+1
    # 複数のcellzoneをmergeする
    mergeValue = []
    for name in mergeName:
        i=0
        while i < len(cellValue):
            if name == cellValue[i][0]:
                for value in cellValue[i][1]:
                    mergeValue.append(value)
            i=i+1
    # mergeできなかった場合、appendしない
    merge = []
    if len(mergeValue) != 0:
        mergeValue.sort()
        merge.append(resultName)
        merge.append(mergeValue)
    i=0; ans = []
    while i < len(cellValue):
        cellName = cellValue[i][0]
        flag = 0
        for name in mergeName:
            if name == cellName:
                flag =1
        if flag == 0:
            ans.append(cellValue[i])
        i=i+1
    #mergeできなかった場合、結果に追加しない
    if len(merge) != 0:
        ans.append(merge)
    return ans

#
#  writeResult
#
def writeResult(wdir, resultNo):
    fileName = wdir + "/cellZones"
    backUpName = wdir + "/cellZones.bak"
    command = "cp " + fileName + " " + backUpName
    os.system(command)
    setFoamContents.cellZones(wdir, resultNo)

    # mergeしたcellZoneをsetsに保存
    setsDir = wdir + "/sets"
    setFoamContents.setsCellZone(setsDir, resultNo[-1])


if __name__ == "__main__":
    cellZoneName = []
    cellZoneName = getParameter()
    setsDir = os.getcwd() + "/constant/polyMesh/sets"
    flag = checkPrintHelp(cellZoneName)
    if flag != "help":
        wdir = os.getcwd() + "/constant/polyMesh"
        print "cellZones内のデータを読込み中..."
        cont = getFoamContents.cellZones(wdir)
        error = checkCellZoneName(cellZoneName, cont)
        if error[0] == "OK":
            cellNo = getOnlyCellNo(cont)
            print "cellZoneをmergeしています..."
            resultNo = mergeCellNo(cellZoneName, cellNo)
            writeResult(wdir, resultNo)
            print "cellZoneをmergeしました。\n"

