#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   mergeCellZones.py
#       setsフォルダ内に抜き出されたcellZoneファイルをmeargeする
#
#       使い方
#       meargeCellZones newName [cellZone_1 cellZone_2 ...]
#
#       10/03/21    新規作成
#

import sys
import os
import glob
import string
import getFoamContents
import setFoamContents


#
#  getParameter
#    cellZoneNameを取得
def getParameter(commArg):
    cellZoneName = []
#    commArg = sys.argv
    i=1
    while i < len(commArg):
        cellZoneName.append(commArg[i])
        i=i+1
    return cellZoneName

#
#  checkPrintHelp
#    helpを出力する。
def checkPrintHelp(cellZoneName):
    flag = ""
    for name in cellZoneName:
        if name[0] == "-":
            msg = "\n<使い方>\n"
            msg = msg + "mergeCellZone [option] <newName> <addedName...>\n"
            msg = msg + "複数のcellZoneをmergeして新しいcellZoneファイルをつくる。\n"
            print msg
            flag = "help"
    return flag

#
#  checkCellZoneName
#    入力したcellZoneNameをチェックする。
def checkCellZoneName(cellZoneName, cont):
    i=1
    while i < len(cellZoneName):
        n=0
        flag = "NG"
        while n < len(cont):
            if cellZoneName[i] == cont[n][0]:
                flag = "OK"
                n = len(cont)
            n=n+1
        if flag == "NG":
            badName = cellZoneName[i]
            i = len(cellZoneName)
        i=i+1
    error = []
    if flag == "NG":
        emsg = u"入力したcellZoneName:" + badName + u" がcellZonesファイル内に定義されていません。\n　入力したcellZoneNameを確認してください。"
        error.append(flag)
        error.append(emsg)
        print "\n" + emsg + "\n"
    else:
        if len(cellZoneName) <= 2:
            emsg = u"mergeするcellZone数が足りません。\n　mergeするcellZoneNameは、2ヶ以上必要です。"
            error.append("NG")
            error.append(emsg)
            print "\n" + emsg + "\n"
        else:
            error.append(flag)
            error.append("")
    return error


# getOnlyCellNo
def getOnlyCellNo(cont):
    n=0; ans = []
    while n < len(cont):
        value = []
        name = cont[n][0]
        allValue = getFoamContents.getValueInContents(0, "(", ")", cont[n][1])
        value.append(name)
        value.append(allValue[1][1])
        ans.append(value)
        n=n+1
    return ans

"""
#  getFlipMap
def getFlipMap(cont):
    flipMap = []
    for flips in cont:
        #flipMapの内容を取得
        flipCont = string.join(flips[1], "\n")
        i=0
        n = string.find(flipCont, "flipMap")
        if n>=0:
            i=n
            n=string.find(flipCont[i:], "{")
            i=i+n
            while flipCont[i] != " ":
                i -= 1
            i=i+1
            n=string.find(flipCont[i:], "}")
            flip = flipCont[i:i+n+1]
            flipMap.append([flips[0], flip])
    return flipMap
"""

#
#  mergeCellNo
#
def mergeCellNo(cellName, cellValue):
    # mergeした結果を保存する名前を取得
    resultName = cellName[0]
    # mergeする名前を取得
    i=1; mergeName = []
    while i < len(cellName):
        mergeName.append(cellName[i])
        i=i+1
    # 複数のcellzoneをmergeする
    mergeValue = []
    for name in mergeName:
        i=0
        while i < len(cellValue):
            if name == cellValue[i][0]:
                for value in cellValue[i][1]:
                    mergeValue.append(value)
            i=i+1
    # mergeできなかった場合、appendしない
    merge = []
    if len(mergeValue) != 0:
        mergeValue.sort()
        merge.append(resultName)
        merge.append(mergeValue)
    i=0; ans = []
    while i < len(cellValue):
        cellName = cellValue[i][0]
        flag = 0
        for name in mergeName:
            if name == cellName:
                flag =1
        if flag == 0:
            ans.append(cellValue[i])
        i=i+1
    #mergeできなかった場合、結果に追加しない
    if len(merge) != 0:
        ans.append(merge)
    return ans

#
#  mergeFaceNo
#
def mergeFaceNo(faceName, faceValue):
    # mergeした結果を保存する名前を取得
    resultName = faceName[0]
    # mergeする名前を取得
    i=1; mergeName = []
    while i < len(faceName):
        mergeName.append(faceName[i])
        i=i+1
    # 複数のcellzoneをmergeする
    mergeValue = []
    for name in mergeName:
        i=0
        while i < len(faceValue):
            if name == faceValue[i][0]:
                for value in faceValue[i][1]:
                    mergeValue.append(value)
            i+=1
    #結果をmergeする
    merge = []
    if len(mergeValue) != 0:
        mergeValue.sort()
        merge.append(resultName)
        merge.append(mergeValue)
    #mergeしないfaceをappend
    i=0; ans = []
    while i < len(faceValue):
        faceName = faceValue[i][0]
        flag = 0
        for name in mergeName:
            if name == faceName:
                flag =1
        if flag == 0:
            ans.append(faceValue[i])
        i=i+1
    #merge分をappend
    ans.append(merge)
    return ans

#
#  writeResult
#
def writeResult(wdir, resultNo):
    fileName = wdir + "/cellZones"
    backUpName = wdir + "/cellZones.bak"
    command = "cp " + fileName + " " + backUpName
    os.system(command)
    setFoamContents.cellZones(wdir, resultNo)

    # mergeしたcellZoneをsetsに保存
    setsDir = wdir + "/sets"
    setFoamContents.setsCellZone(setsDir, resultNo[-1])

#
#  writeResultFaceZone
#
def writeResultFaceZone(wdir, resultNo):
    fileName = wdir + "/faceZones"
    backUpName = wdir + "/faceZones.bak"
    command = "cp " + fileName + " " + backUpName
    os.system(command)
    setFoamContents.faceZones(wdir, resultNo)
    # mergeしたcellZoneをsetsに保存
    setsDir = wdir + "/sets"
    setFoamContents.setsfaceZone(setsDir, resultNo[-1])
    

#
#  RunFace
#    faceZoneを結合する
#   引数: [<command>, <newName>, <mergeName1>, <mergeName2>, ...]
#   戻値: [<"OK" or "NG">, <エラーメッセージ>] 
def RunFace(commArg):
    faceZoneName = []
    faceZoneName = getParameter(commArg)
    setsDir = os.getcwd() + "/constant/polyMesh/sets"
    wdir = os.getcwd() + "/constant/polyMesh"
    print "faceZones内のデータを読込み中..."
    cont = getFoamContents.faceZones(wdir)
    error = checkCellZoneName(faceZoneName, cont)
    if error[0] == "OK":
        faceNo = getOnlyCellNo(cont)
        #flipMap = getFlipMap(cont)
        print "faceZoneをmergeしています..."
        resultNo = mergeFaceNo(faceZoneName, faceNo)
        writeResultFaceZone(wdir, resultNo)
    return error

#
# Run
#   引数: [<command>, <newName>, <mergeName1>, <mergeName2>, ...]
#   戻値: [<"OK" or "NG">, <エラーメッセージ>] 
def Run(commArg):
    cellZoneName = []
    cellZoneName = getParameter(commArg)
    setsDir = os.getcwd() + "/constant/polyMesh/sets"
    wdir = os.getcwd() + "/constant/polyMesh"
    print "cellZones内のデータを読込み中..."
    cont = getFoamContents.cellZones(wdir)
    error = checkCellZoneName(cellZoneName, cont)
    if error[0] == "OK":
        cellNo = getOnlyCellNo(cont)
        print "cellZoneをmergeしています..."
        resultNo = mergeCellNo(cellZoneName, cellNo)
        writeResult(wdir, resultNo)
        print "cellZoneをmergeしました。\n"
    return error



if __name__ == "__main__":
    cellZoneName = []
    commArg = sys.argv
    cellZoneName = getParameter(commArg)
    setsDir = os.getcwd() + "/constant/polyMesh/sets"
    flag = checkPrintHelp(cellZoneName)
    if flag != "help":
        wdir = os.getcwd() + "/constant/polyMesh"
        print "cellZones内のデータを読込み中..."
        cont = getFoamContents.cellZones(wdir)
        error = checkCellZoneName(cellZoneName, cont)
        if error[0] == "OK":
            cellNo = getOnlyCellNo(cont)
            print "cellZoneをmergeしています..."
            resultNo = mergeCellNo(cellZoneName, cellNo)
            writeResult(wdir, resultNo)
            print "cellZoneをmergeしました。\n"

