#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Thu Mar 11 21:50:08 2010
#
#  selectFieldsForEditDialog.py
#
#     Fieldsの選択
#                   folder1                     folder2
#       入力データ:[[folder1,field1,field2,..], [folder2,field1,field2,..], ...]
#
#       12/03/25    新規作成（selectFieldsForEditDialogを変更して作成）
#       12/05/28    ﾊﾞｸﾞ修正（openコマンド時、設定されたfield順番が反映されなかった）
#

import wx
import os
import glob
import string
import treefoam
import pyOFLauncher
import pyTreeFoam
import setFoamContents
import getFoamContents
import editBoundaryConditionsDialog

job = ""
title = ""
img = ""
message = ""
folderFieldList = []
fieldList = []
folderList = []
selectedFields = []
frame_1 = ""
editDir = ""
nTreeFoamD = ""
time = ""
timeDir = ""


#  Show
#    FFlist:dummy（使っていない）
#    editDir、time：ここからFFlist（folderFieldList）を作る
def Show(nTreeFoam1, title1, mess1, FFlist, editDir1, time1):
    global frame_1, title, img, message, fieldList, folderList, selectedFields, folderFieldList, editDir, nTreeFoam, time, timeDir
    nTreeFoam = nTreeFoam1
    title = title1
    time = time1
    message = mess1
    editDir = editDir1
    timeDir = editDir + "/" + time
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
    return selectedFields



#----------------以下の内容を変更-----------------------------
#
#  アイコン変更
#　　絶対path→相対path
#



# begin wxGlade: extracode
# end wxGlade


class MyFrame(wx.Frame):
    global job, frame_1, fieldList, folderList, selectedFields, folderFieldList, message, img, title, editDir, nTreeFoam
    def __init__(self, *args, **kwds):

        #currentDirの保存
        saveDir = os.getcwd()
        treeFoamPath = os.getenv("HOME") + "/TreeFoam"
        os.chdir(treeFoamPath)

        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.bitmap_1 = wx.StaticBitmap(self, -1, wx.Bitmap("./icons/emblem-documents.png", wx.BITMAP_TYPE_ANY))
        self.label_1 = wx.StaticText(self, -1, u"選択された Boundary boundaryField を gridEditor で開きます")
        self.label_3 = wx.StaticText(self, -1, u"編集する時間")
        self.combo_box_1 = wx.ComboBox(self, -1, choices=["0", "0.1"], style=wx.CB_DROPDOWN)
        self.bitmap_2 = wx.StaticBitmap(self, -1, wx.Bitmap("./icons/folder8.png", wx.BITMAP_TYPE_ANY))
        self.label_4 = wx.StaticText(self, -1, u"Folderを選択")
        self.bitmap_3 = wx.StaticBitmap(self, -1, wx.Bitmap("./icons/text8.png", wx.BITMAP_TYPE_ANY))
        self.label_2 = wx.StaticText(self, -1, u"Fieldを選択")
        self.checkbox_1 = wx.CheckBox(self, -1, u"全てのFieldを選択")
        self.list_box_2 = wx.ListBox(self, -1, choices=[u"(現在のフォルダ)"], style=wx.LB_MULTIPLE)
        self.list_box_1 = wx.ListBox(self, -1, choices=["Je", "ElPot"], style=wx.LB_MULTIPLE)
        self.button_1 = wx.Button(self, -1, u"キャンセル")
        self.button_3 = wx.Button(self, -1, u"開く")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_COMBOBOX, self.onSelectTime, self.combo_box_1)
        self.Bind(wx.EVT_CHECKBOX, self.changeListBoxStatus, self.checkbox_1)
        self.Bind(wx.EVT_LISTBOX, self.showFields, self.list_box_2)
        self.Bind(wx.EVT_BUTTON, self.cancel, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.showGrid, self.button_3)
        # end wxGlade

        #currentDirの復帰
        os.chdir(saveDir)
        #FFlist作成
        self.changeTimeFolder()


    def __set_properties(self):
        global nTreeFoam
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(u"Boundaryを開く")
        self.combo_box_1.SetSelection(0)
        self.label_2.Enable(False)
        self.checkbox_1.SetValue(1)
        self.list_box_2.SetMinSize((200, 150))
        self.list_box_2.SetSelection(0)
        self.list_box_1.SetMinSize((200, 150))
        self.list_box_1.Enable(False)
        self.list_box_1.SetSelection(0)
        self.button_1.SetFocus()
        # end wxGlade
        self.SetTitle(title + " (" + nTreeFoam + ")")
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(folderList)
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(fieldList)
        self.list_box_2.Select(0)
        #チェックボックス、リストボックスを設定
        self.setCheckBox_listBox(editDir, folderList, fieldList)
        #コンボボックスを設定
        self.setComboBox()

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_10 = wx.BoxSizer(wx.VERTICAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_2.Add(self.bitmap_1, 0, 0, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_2.Add(self.label_1, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_1.Add(sizer_2, 0, wx.EXPAND, 0)
        sizer_7.Add((20, 20), 0, 0, 0)
        sizer_7.Add(self.label_3, 0, wx.TOP, 10)
        sizer_1.Add(sizer_7, 0, wx.EXPAND, 0)
        sizer_6.Add((20, 20), 0, 0, 0)
        sizer_6.Add(self.combo_box_1, 0, wx.BOTTOM, 5)
        sizer_1.Add(sizer_6, 0, wx.EXPAND, 0)
        sizer_4.Add((20, 20), 0, 0, 0)
        sizer_4.Add(self.bitmap_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_4.Add(self.label_4, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_4.Add((120, 20), 0, 0, 0)
        sizer_4.Add(self.bitmap_3, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_4.Add(self.label_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_4.Add((10, 20), 0, 0, 0)
        sizer_4.Add(self.checkbox_1, 0, 0, 0)
        sizer_1.Add(sizer_4, 0, wx.EXPAND, 0)
        sizer_8.Add((20, 20), 0, 0, 0)
        sizer_9.Add(self.list_box_2, 1, 0, 0)
        sizer_8.Add(sizer_9, 0, wx.EXPAND, 0)
        sizer_8.Add((20, 20), 0, 0, 0)
        sizer_10.Add(self.list_box_1, 1, 0, 0)
        sizer_8.Add(sizer_10, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_3.Add((160, 20), 0, wx.ALIGN_RIGHT, 0)
        sizer_3.Add(self.button_1, 0, wx.LEFT, 0)
        sizer_3.Add((10, 20), 0, 0, 0)
        sizer_3.Add(self.button_3, 0, 0, 0)
        sizer_1.Add(sizer_3, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 10), 0, 0, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #チェックボックス、リストボックスの設定
    def setCheckBox_listBox(self, editDir, folderList, fieldList):
        fileName = editBoundaryConditionsDialog.getSaveDisplayFieldsFileName(editDir)
        if len(glob.glob(fileName)) != 0:
            self.label_2.Enable(True)
            self.checkbox_1.SetValue(0)
            self.list_box_1.Enable(True)
            dispNames = editBoundaryConditionsDialog.getDisplayFields(fileName)
            i = 0
            for name in fieldList:
                for dispName in dispNames:
                    if name == dispName:
                        self.list_box_1.Select(i)
                        break
                i += 1

    #コンボボックスの設定
    def setComboBox(self):
        global time, editDir
        numDir = string.join(editDir.split("/")[:-1], "/")
        times = pyTreeFoam.getTimeFolders(numDir)
        self.combo_box_1.Clear()
        i=0
        for item in times:
            self.combo_box_1.Append(times[i])
            i += 1
        self.combo_box_1.SetStringSelection(time)


    #checkBoxのcheckを変えた時の処理
    def changeListBoxStatus(self, event): # wxGlade: MyFrame.<event_handler>
        global editDir, folderFieldList, timeDir
        if self.checkbox_1.Value == True:
            self.label_2.Enable(False)
            self.list_box_1.Enable(False)
            #displayFieldファイルを削除
            self.deleteDisplayFieldIfPresent()
            #listBox内のfieldを書き換え
            folderFieldList = self.setFFlist(timeDir)
            folderNo = self.list_box_2.GetSelections()
            if len(folderNo) > 0:
                fields = folderFieldList[folderNo[0]]
                fieldList = fields[1:]
                self.list_box_1.Clear()
                self.list_box_1.AppendItems(fieldList)
        else:
            self.label_2.Enable(True)
            self.list_box_1.Enable(True)

    #timeを変えたときの処理
    def onSelectTime(self, event): # wxGlade: MyFrame.<event_handler>
        self.changeTimeFolder()

    #フォルダを選択した時の処理
    def showFields(self, event): # wxGlade: MyFrame.<event_handler>
        self.setFieldsToListBox()

    #cancelボタン
    def cancel(self, event): # wxGlade: MyFrame.<event_handler>
        global selectedFields
        print "exit from selectFieldsDialog."
        selectedFields = []
        self.Destroy()

    #OKボタン
    def showGrid(self, event): # wxGlade: MyFrame.<event_handler>
        global selectedFields, folderFieldList, nTreeFoam
        selectedFields = []
        folderNo = self.list_box_2.GetSelections()
        if (len(folderNo) == 0):
            selectedFields = []
        elif len(folderNo) == 1:
            nn = folderNo[0]
            if self.checkbox_1.Value == True:
                selectedFields.append(folderFieldList[nn])
            else:
                fields = []
                fields.append(folderFieldList[nn][0])
                fieldNo = self.list_box_1.GetSelections()
                for n in fieldNo:
                    fields.append(folderFieldList[nn][n+1])
                selectedFields.append(fields)
        elif (len(folderNo) > 1):
            if job == "editField":
                selectedFields = []
                title = "error"
                msg = "boundary Field の編集では、複数のフォルダを選択できません。"
                self.errDialog(title, msg)
            else:
                for n in folderNo:
                    selectedFields.append(folderFieldList[n])
        else:
            selectedFields = []

        #Grid編集
        if len(selectedFields[0]) > 1:
            #title, dirを設定
            caseFolder = editDir.split("/")[-2]
            timeFolder = self.combo_box_1.GetStringSelection()
            title = ": " + caseFolder + "/" + timeFolder + "/" + selectedFields[0][0]
            fieldDir = string.join(editDir.split("/")[:-1], "/") + "/" + timeFolder + "/" + selectedFields[0][0]
            boundaryDir = getBoundaryDir(fieldDir)
            #patchDataをFieldから取得
            try:
                #fieldを取得
                fields = selectedFields[0][1:]
                fields = self.changeOrder(fieldDir, fields)
                #patch名をboundatyから取得
                values = getFoamContents.getPatchNameFromBoundary(boundaryDir)
                patches = []
                for patchG in values:
                    patches.append(patchG[0])
                #表示設定ファイルチェック
                if self.checkbox_1.Value == True:
                    fileName = editBoundaryConditionsDialog.getSaveDisplayFieldsFileName(fieldDir)
                    if len(glob.glob(fileName)) != 0:
                        comm = "rm " + fileName
                        os.system(comm)
                        title = u"表示設定ファイルの削除"
                        mess = u"fieldの非表示、表示設定ファイルを削除しました。"
                        self.okDialog(title, mess)
                else:
                    editBoundaryConditionsDialog.saveDisplayFields(fields, fieldDir)
                #Grid表示
                self.Destroy()
                editBoundaryConditionsDialog.Show(nTreeFoam, title, boundaryDir,
                        fieldDir, fields)
            except:
                title = u"エラー"
                mess = u"オープンできないfieldがあります。\n" + editDir + u" 内のfieldを確認してください。"
                self.errDialog(title, mess)
        else:
            title = "エラー"
            mess = u"Fieldが選択されていません。\n  Fieldを選択してください。"
            self.errDialog(title, mess)
        event.Skip()

    #  changeOrder
    #    順番を修正
    def changeOrder(self, fieldDir, fields):
        newFields = []
        fileName = editBoundaryConditionsDialog.getSaveDisplayFieldsFileName(fieldDir)
        if len(glob.glob(fileName)) != 0:
            dispFields = editBoundaryConditionsDialog.getDisplayFields(fileName)
            for dispField in dispFields:
                i=0
                while i < len(fields):
                    if dispField == fields[i]:
                        newFields.append(dispField)
                        i = len(fields)
                    i += 1
        else:
            newFields = fields
        return newFields


    #  checkBadField
    #    patchDataのチェック、エラー表示
    def checkBadField(self, fields, patches, patchesF, patchData):
        #patchDataを修正
        data=[]; j=0
        for fieldPatch in patchData:
            fieldData=[]
            for patch in patches:
                i=0; flag=0
                while i<len(fieldPatch) and flag==0:
                    if patch == patchesF[i]:
                        fieldData.append(fieldPatch[i])
                        flag = 1
                    i+=1
                if flag == 0:
                    fieldData.append("")
            data.append(fieldData)
            j+=1
        #patchDataをチェック
        patchData = data
        i=0; badFields=[]
        while i<len(fields):
            flag = 0
            for bpData in patchData[i]:
                if bpData == "":
                    flag = 1
                    badFields.append(fields[i])
                    break
            i+=1
        if len(badFields) > 0:
            title = u"エラー"
            mess = u"「" + string.join(badFields, ",") + u"」のfieldが正しく読み込めていません。"
            self.warnDialog(title, mess)
        #PatchDataの文字数をチェック、修正
        data=[]
        for field in patchData:
            i=0
            while i<len(field):
                #200文字以上の場合チェックする
                if len(field[i]) > 100:
                    patchCont = field[i][:1000].split("\n")
                    #20行以上の場合は、20行に縮める
                    if len(patchCont) > 15:
                        field[i] = string.join(patchCont[:15], "\n")+"..."
                i+=1
            data.append(field)
        patchData = data
        return patchData

    #  deleteDisplayFieldIfPresent()
    #    displayFieldファイルがあれば削除する
    def deleteDisplayFieldIfPresent(self):
        global folderFieldList, timeDir
        folderNo = self.list_box_2.GetSelections()
        if len(folderNo) > 0:
            folderName = folderFieldList[folderNo[0]][0]
            fieldDir = timeDir + "/" + folderName
            fileName = editBoundaryConditionsDialog.getSaveDisplayFieldsFileName(fieldDir)
            if len(glob.glob(fileName)) != 0:
                comm = "rm " + fileName
                os.system(comm)

    #  changeTimeFolder
    #    timeを変更
    def changeTimeFolder(self):
        global time, editDir, folderFieldList, timeDir
        time = self.combo_box_1.GetValue()
        editDir = string.join(editDir.split("/")[:-1], "/") + "/" + time
        timeDir = editDir
        folderFieldList = self.setFFlist(editDir)
        self.setFolderList(folderFieldList)
        self.setFieldsToListBox()


    #  setFFlist
    #    set folderFieldList
    def setFFlist(self, timeFolder):
        ans = []
        [folders, fields] = pyTreeFoam.getFoldersFiles(timeFolder)
        folders.sort()
        folderFields = ["."]
        for field in fields:
            folderFields.append(field)
        ans.append(folderFields)
        if len(folders) != 0:
            for folder in folders:
                folderFields = [folder]
                fieldDir = timeFolder + "/" + folder
                [dummy, files] = pyTreeFoam.getFoldersFiles(fieldDir)
                fields = self.checkDispFields(fieldDir, files)
                fields.sort()
                for field in fields:
                    folderFields.append(field)
                ans.append(folderFields)
        return ans


    def checkDispFields(self, fieldDir, fields):
        fileName = editBoundaryConditionsDialog.getSaveDisplayFieldsFileName(fieldDir)
        if len(glob.glob(fileName)) != 0:
            dispFields = editBoundaryConditionsDialog.getDisplayFields(fileName)
            for dispField in dispFields:
                flag = 0
                for field in fields:
                    if dispField == field:
                        flag = 1
                        break
                if flag == 0:
                    fields.append(dispField)
        return fields


    #  setFolderList
    #    folder名をlistBoxにセット
    def setFolderList(self, folderFieldsList):
        global folderList
        newFolders = []
        for folderFields in folderFieldsList:
            newFolders.append(folderFields[0])
        newFolders[0] = "(現在のフォルダ)"
        folderList = newFolders
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(newFolders)
        self.list_box_2.SetSelection(0)


    #  setFieldsToListBox
    #    field名をlistboxにセットしeditDirをセット
    def setFieldsToListBox(self):
        global folderFieldList, editDir
        folderNo = self.list_box_2.GetSelections()
        if len(folderNo) > 0:
            fields = folderFieldList[folderNo[0]]
            fieldList = fields[1:]
            self.list_box_1.Clear()
            self.list_box_1.AppendItems(fieldList)
            #checkbox=ON
            self.checkbox_1.SetValue(1)
            self.label_2.Enable(False)
            self.list_box_1.Enable(False)
            if folderNo[0] == 0:
                fieldDir = editDir
            else:
                fieldDir = editDir + "/" + folderList[folderNo[0]]
            self.setCheckBox_listBox(fieldDir, folderList, fieldList)



    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        if ans == wx.ID_OK:
            dlg.Destroy()
            return "OK"
        else:
            dlg.Destroy()
            return "CANCEL"

    #警告
    def warnDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.ICON_EXCLAMATION) 
        ans = dlg.ShowModal()
        dlg.Destroy()

    #エラー
    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.ICON_HAND) 
        ans = dlg.ShowModal()
        dlg.Destroy()

    #OK
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        dlg.Destroy()

# end of class MyFrame



def editFields(editList):
    if len(editList) != 0:
        i = 0; arg = ""
        while i < len(editList):
            j = 1
            while j < len(editList[i]):
                arg = arg + editList[i][0] + "/" + editList[i][j] + " "
                j = j + 1
            i = i + 1
        pyTreeFoam.runEditor(arg)
        """
        command = "gedit --new-window " + arg + " &"
        os.system(command)
        """

#
#  getBoundaryDir
#    fieldDirからboundaryのDirを探す。
#    (chtMultiRegion or conjugate)
def getBoundaryDir(fieldDir):
    folders = fieldDir.split("/")
    #Case内 ?
    if folders[-1] == ".":
        boundaryDir = string.join(folders[:-2], "/") + "/constant/polyMesh"
    else:
        #mutiRegion ?
        wdir = fieldDir + "/polyMesh"
        if len(glob.glob(wdir)) > 0:
            boundaryDir = wdir
        else:
            #conjugate ?
            wdir = string.join(folders[:-2], "/") + "/constant/" + folders[-1] + "/polyMesh"
            if len(glob.glob(wdir)) > 0:
                boundaryDir = wdir
            else:
                #それ以外
                boundaryDir = ""
    return boundaryDir



if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
