#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   runParallelDialog.py
#
#       並列計算の設定、実行
#
#   12/04/30    新規作成
#

# generated by wxGlade 0.6.3 on Mon Apr 30 10:37:28 2012

import wx
import os
import glob

import treefoam
import setFoamContents
import pyTreeFoam


caseDir = ""

# begin wxGlade: extracode
# end wxGlade



def Show(caseDir1):
    global caseDir
    caseDir = caseDir1
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.sizer_10_staticbox = wx.StaticBox(self, -1, u"領域分割")
        self.sizer_4_staticbox = wx.StaticBox(self, -1, u"並列計算")
        self.sizer_12_staticbox = wx.StaticBox(self, -1, u"結果の確認")
        self.sizer_2_staticbox = wx.StaticBox(self, -1, u"設定ファイルの作成")
        self.label_1 = wx.StaticText(self, -1, u"並列計算の設定、計算開始")
        self.button_1 = wx.Button(self, -1, u"machines編集")
        self.button_2 = wx.Button(self, -1, u"接続状態の確認")
        self.label_2 = wx.StaticText(self, -1, u"並列計算するsubDomainを定義。\n（/etc/hostsで定義されているhostから選択）")
        self.button_3 = wx.Button(self, -1, u"decomposeParDict編集")
        self.label_3 = wx.StaticText(self, -1, u"各cpu毎のmesh分割方法を定義。\n既にmeshを領域分割している場合は不要")
        self.button_4 = wx.Button(self, -1, u"mesh分割")
        self.button_10 = wx.Button(self, -1, u"各nodeに領域配布")
        self.label_4 = wx.StaticText(self, -1, u"cpu毎に領域分割、node毎に領域配布")
        self.button_5 = wx.Button(self, -1, u"並列計算開始")
        self.button_6 = wx.Button(self, -1, u"lam(mpi)の停止")
        self.label_5 = wx.StaticText(self, -1, u"並列計算を開始します（mpirun）")
        self.button_7 = wx.Button(self, -1, u"結果の再構築")
        self.label_6 = wx.StaticText(self, -1, u"実行後、cpu毎の計算結果を集め、結果を再構築します。")
        self.button_9 = wx.Button(self, -1, u"閉じる")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onEditMachines, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onCheckNodes, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onEditDecomposeParDict, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onDecomposePar, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onDistToNode, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onRunMpi, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onHaltMpi, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onReconstruct, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_9)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(u"並列計算")
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_12 = wx.StaticBoxSizer(self.sizer_12_staticbox, wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_10 = wx.StaticBoxSizer(self.sizer_10_staticbox, wx.VERTICAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_3.Add(self.button_1, 0, wx.LEFT|wx.RIGHT|wx.TOP, 10)
        sizer_3.Add(self.button_2, 0, wx.LEFT|wx.RIGHT|wx.TOP, 10)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_2.Add(self.label_2, 0, wx.LEFT, 20)
        sizer_2.Add(self.button_3, 0, wx.LEFT|wx.RIGHT|wx.TOP, 10)
        sizer_2.Add(self.label_3, 0, wx.LEFT, 20)
        sizer_1.Add(sizer_2, 0, wx.ALL|wx.EXPAND, 5)
        sizer_11.Add(self.button_4, 0, wx.LEFT|wx.RIGHT|wx.TOP, 10)
        sizer_11.Add(self.button_10, 0, wx.LEFT|wx.RIGHT|wx.TOP, 10)
        sizer_10.Add(sizer_11, 1, wx.EXPAND, 0)
        sizer_10.Add(self.label_4, 0, wx.LEFT, 20)
        sizer_1.Add(sizer_10, 1, wx.ALL|wx.EXPAND, 5)
        sizer_5.Add(self.button_5, 0, wx.LEFT|wx.RIGHT|wx.TOP, 10)
        sizer_5.Add(self.button_6, 0, wx.LEFT|wx.RIGHT|wx.TOP, 10)
        sizer_4.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_4.Add(self.label_5, 0, wx.LEFT, 20)
        sizer_1.Add(sizer_4, 1, wx.ALL|wx.EXPAND, 5)
        sizer_13.Add(self.button_7, 0, wx.LEFT|wx.RIGHT|wx.TOP, 10)
        sizer_12.Add(sizer_13, 1, wx.EXPAND, 0)
        sizer_12.Add(self.label_6, 0, wx.LEFT, 20)
        sizer_1.Add(sizer_12, 1, wx.ALL|wx.EXPAND, 5)
        sizer_6.Add((200, 20), 0, 0, 0)
        sizer_6.Add(self.button_9, 0, wx.ALL, 10)
        sizer_1.Add(sizer_6, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #machines編集
    def onEditMachines(self, event): # wxGlade: MyFrame.<event_handler>
        print "並列計算：machinesを編集します。"
        self.editMachines()
        event.Skip()

    #接続状態の確認
    def onCheckNodes(self, event): # wxGlade: MyFrame.<event_handler>
        print "並列計算：接続状態を確認します。"
        self.checkConnectedNodes()
        event.Skip()

    #decomposeParDict編集
    def onEditDecomposeParDict(self, event): # wxGlade: MyFrame.<event_handler>
        print "並列計算：decomposeParDictを編集します。"
        self.editDecomposeParDict()
        event.Skip()

    #メッシュ分割
    def onDecomposePar(self, event): # wxGlade: MyFrame.<event_handler>
        print "並列計算：メッシュを分割します。"
        self.runDecomposePar()
        event.Skip()

    #メッシュ分配
    def onDistToNode(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `onDistToNode' not implemented!"
        event.Skip()

    #並列計算開始
    def onRunMpi(self, event): # wxGlade: MyFrame.<event_handler>
        print "並列計算を開始します。"
        self.runMpi()
        event.Skip()

    def onHaltMpi(self, event): # wxGlade: MyFrame.<event_handler>
        print "lam, mpiを停止します。"
        self.haltMpi()
        event.Skip()

    def onReconstruct(self, event): # wxGlade: MyFrame.<event_handler>
        print "結果を集め再構築します。"
        self.reconstruct()
        event.Skip()

    #Close
    def onClose(self, event): # wxGlade: MyFrame.<event_handler>
        self.Destroy()
        event.Skip()


    #  editMachies
    #    machinesの編集
    def editMachines(self):
        global caseDir
        machinesFile = treefoam.machinesFile
        fileName = caseDir + "/" + machinesFile
        if len(glob.glob(fileName)) == 0:
            cont = setFoamContents.makeMachinesDefault()
            f=open(fileName,"w"); f.write(cont); f.close()
            msg = "machinesがなかったので、標準の「machines」を作成しました。\n 「localhost cpu=4」で作成しています。"
            self.okDialog(u"並列計算", msg)
        pyTreeFoam.runEditor(fileName)

    #  checkConnectedNodes
    #    接続状態を確認
    def checkConnectedNodes(self):
        global caseDir
        machinesFile = treefoam.machinesFile
        fileName = caseDir + "/" + machinesFile
        if len(glob.glob(fileName)) == 0:
            title = u"nodeの表示"
            message = u"現在の解析Case内に「mashines」ファイルがありません。\n「machines」で並列計算させるノードを設定してください。"
            self.errDialog(title, message)
            return
        tempFile = caseDir + "/nodes.temp"
        command = "lamboot -v machines; lamnodes | tee " + tempFile + "; lamhalt -d"
        pyTreeFoam.runOFUtility(command)
        f=open(tempFile); cont=f.read(); f.close()
        message = u"接続されているノードを表示します。\n\nnode\t内容\n-------------------------------------\n" + cont
        os.system("rm -rf " + tempFile)
        title = u"nodeの表示"
        self.okDialog(title, message)

    #  editDecomposeParDict
    #    decomposeParDictを編集する
    def editDecomposeParDict(self):
        global caseDir
        fileName = caseDir + "/system/decomposeParDict"
        if len(glob.glob(fileName)) == 0:
            cont = setFoamContents.makeDecomposeParDictDefault()
            f=open(fileName,"w"); f.write(cont); f.close()
            msg = u"deconposeParDictが無かったので、標準のdecomposeParDictを作成しました。"
            self.okDialog(u"decomposeParDictの編集", msg)
        pyTreeFoam.runEditor(fileName) 


    #  runDecomposePar
    #    meshをcpu毎に分割
    def runDecomposePar(self):
        global caseDir
        saveDir = os.getcwd()
        os.chdir(caseDir)
        #既に分割ファイルがある場合は、削除する
        processorfile = caseDir + "/processor*"
        nCPU = len(glob.glob(caseDir + "/processor*"))
        if nCPU != 0:
            while nCPU > 0:
                cpuName = str(nCPU-1)
                command = "rm -rf processor" + cpuName
                print command
                os.system(command)
                nCPU -= 1
        #領域分割
        if len(glob.glob("./constant/cellToRegion")) != 0:
            #cellToRegionで領域分割されている場合
            zones = getFoamContents.cellZoneNames()
            comm = ""
            for zone in zones:
                comm = comm + "decomposePar -region " + zone + "\n"
            pyTreeFoam.runOFUtility(comm)
        else:
            #decomposeParで分割
            comm = "decomposePar"
            pyTreeFoam.runOFUtility(comm)
        mess = u"cpu毎にメッシュを分割しました。"
        title = u"並列計算"
        self.okDialog(title, mess)
        os.chdir(saveDir)

    #  runMpi
    #    並列計算開始
    def runMpi(self):
        global caseDir
        solver = treefoam.getSolver(caseDir)
        nCpu = len(glob.glob(caseDir + "/processor*"))
        if solver != "" and nCpu>1:
            #dir保存
            saveDir = os.getcwd()
            os.chdir(caseDir)
            #solve.ogのクリア
            f=open("solve.log", "w"); f.close()
            #solverの実行ファイル作成
            envOF = pyTreeFoam.getBashrcFoam()
            cont  = "#!/bin/bash\n"
            cont += ". " + envOF + "\n"
            cont += "lamboot -v machines\n"
            cont += "mpirun -np " + str(nCpu) + " " + solver + " -parallel | tee solve.log\n"
            f=open("run", "w"); f.write(cont); f.close()
            #実行権付与
            os.system("chmod a+x run")
            #実行
            caseName = caseDir.split("/")[-1]
            comm = "gnome-terminal -t " + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run"
            os.system(comm)
            #dirを元に戻す
            os.chdir(saveDir)
        else:
            title = u"エラー"
            if solver == "":
                message = u"「controlDict」は、存在しません。\n"
                message += u"  case directoryが間違っています。"
            else:
                message = u"メッシュが並列計算用に領域分割されていません。" 
            self.okDialog(title, message)

    #  haltMpi
    #    lam, mpiの中断
    def haltMpi(self):
        global caseDir
        saveDir = os.getcwd()
        os.chdir(caseDir)
        comm = "lamhalt -d"
        pyTreeFoam.runOFUtility(comm)
        os.chdir(saveDir)
        print "\nlamを停止しました。"

    #  reconstruct
    #    結果を再構築します
    def reconstruct(self):
        global caseDir
        saveDir = os.getcwd()
        os.chdir(caseDir)
        comm = "reconstructPar"
        pyTreeFoam.runOFUtility(comm)
        os.chdir(saveDir)


    #------------------------------
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

# end of class MyFrame


if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
